// AlphaChannel.cpp : AvP[Vp̃Gg |Cg̒`
//

#include "stdafx.h"

#include "SDIB32GL.H"
#include "util.h"

/*** C^[tFCX̏ ***/
LPSDIB32GLFACTORY	lpSDFactory = NULL;
LPSDIB32GL			lpBack		= NULL;
LPSDIB32GL			lpBg		= NULL;
LPSDIB32GL			lpSprite	= NULL;

#define MAX_OBJ		4

struct {
	long	x;
	long	y;
	long	dir_x;
	long	dir_y;
}obj[MAX_OBJ];

long obj_max_x;
long obj_max_y;


/*----------------------------------------------------------------------------*
|	App
*----------------------------------------------------------------------------*/
BOOL AppInitialize( void )
{	
	HRESULT hr;
	LPSDIB32GL	lpAChannel = NULL;

	try
	{
		// t@NgC^[tFCX擾
		hr = SDIB32GLFactoryCreate( 
			SDIB32GLCREATE_AUTO, (void**)&lpSDFactory, IID_ISDib32GLFactory );

		if( FAILED( hr ) )
		{
			throw exception("t@NgC^[tFCXs");
		}

		// NCAg̈TCỸobNobt@쐬
		hr = lpSDFactory->CreateBuffer(
			CLIENT_WIDTH, CLIENT_HEIGHT, 0, NULL, &lpBack );

		if( FAILED( hr ) )
		{
			throw exception("obNobt@̍쐬Ɏs");
		}

		// BGǂݍ
		hr = lpSDFactory->CreateBufferFromFile(
			MEDIAPATH( OLESTR("BackGround.bmp") ), 0, NULL, 0, NULL, &lpBg );

		if( FAILED( hr ) )
		{
			throw exception("t@C̓ǂݍ݂Ɏs");
		}

		// XvCgǂݍ
		hr = lpSDFactory->CreateBufferFromFile(
			MEDIAPATH( OLESTR("AlphaChannel.bmp") ), 0, NULL, 0, NULL, &lpSprite );

		if( FAILED( hr ) )
		{
			throw exception("t@C̓ǂݍ݂Ɏs");
		}

		// `lǂݍ
		// rbg}bv̑Ƀ`li[łTARGA(32rbg)gƂ߂܂
		hr = lpSDFactory->CreateBufferFromFile( 
			MEDIAPATH( L"AlphaChannel_a.bmp" ), 0, NULL, 0, NULL, &lpAChannel );

		if( FAILED( hr ) )
		{
			throw exception("t@C̓ǂݍ݂Ɏs");
		}
		
		// ԐF(mNȂ̂łǂ3FłOK)`lƂē]
		lpSprite->RToAlphaBlt( lpAChannel, 0, 0, NULL, NULL, NULL );

		// `lf[^̉
		SAFE_RELEASE( lpAChannel );
	}


	// G[
	catch( exception& e )
	{
		
		MessageBox( hWnd, e.what(), szTitle, MB_OK | MB_ICONSTOP );

		// N[Abv
		SAFE_RELEASE( lpAChannel );

		AppCleanUp();

		return FALSE;
	}


	SetTextMode( lpBack );
	
	SIZE size;

	// obt@TCY̎擾
	lpSprite->GetSize( &size );

	RANDOMIZE;
	
	obj_max_x = CLIENT_WIDTH-size.cx;
	obj_max_y = CLIENT_HEIGHT-size.cy;

	for( int i = 0; i < MAX_OBJ; i++ )
	{
		obj[i].x = rand()%obj_max_x;
		obj[i].y = rand()%obj_max_y;
		obj[i].dir_x = ((-rand())%2)|1;
		obj[i].dir_y = ((-rand())%2)|1;
	}

	return TRUE;
}


/*----------------------------------------------------------------------------*
|	AppACh
*----------------------------------------------------------------------------*/
void AppIdle( void )
{

	lpBack->Blt( lpBg, 0, 0, NULL, NULL, NULL );
	
	SIZE size;
	lpSprite->GetSize( &size );

	// XvCg`l]
	for( int i = 0; i < MAX_OBJ; i++ )
	{
		obj[i].x += obj[i].dir_x*2;
		obj[i].y += obj[i].dir_y*2;

		if( obj[i].x < 0 )
		{
			obj[i].x = 0;
			obj[i].dir_x = -obj[i].dir_x;
		}else if( obj[i].x > obj_max_x )
		{
			obj[i].x = obj_max_x;
			obj[i].dir_x = -obj[i].dir_x;
		}

		if( obj[i].y < 0 )
		{
			obj[i].y = 0;
			obj[i].dir_y = -obj[i].dir_y;
		}else if( obj[i].y > obj_max_y )
		{
			obj[i].y = obj_max_y;
			obj[i].dir_y = -obj[i].dir_y;
		}

		lpBack->AlphaChannelBlt( lpSprite, obj[i].x, obj[i].y, &size, NULL, &size );
	}

	// ̕`
	DrawInfo( lpBack );


	// ĕ`
	//*
	HDC hDC = GetDC( hWnd );
	lpBack->Draw( hDC );
	ReleaseDC( hWnd, hDC );
	/*/
	InvalidateRect( hWnd, NULL, FALSE );
	UpdateWindow( hWnd );
	//*/
}


/*----------------------------------------------------------------------------*
|	AppN[Abv
*----------------------------------------------------------------------------*/
void AppCleanUp( void )
{
	SAFE_RELEASE( lpSprite );
	SAFE_RELEASE( lpBg );
	SAFE_RELEASE( lpBack );
	SAFE_RELEASE( lpSDFactory );
}


/*----------------------------------------------------------------------------*
|	WM_PAINT
*----------------------------------------------------------------------------*/
void OnPaint( HDC hdc )
{
	if( lpBack == NULL ) return;

	lpBack->Draw( hdc );
}


