//***********************************************************************
//	SDIB32GL.H
//	
//	SELNA DIB 32bit Graphic Libraries include file
//
//	ver 1.00 (build2004/04/17)	
//	WebSite: http://selna.hp.infoseek.co.jp
//	E-Mail: selna_id@yahoo.co.jp
//
//	Copyright(C) 2004 SELNA. All rights reserved.
//**********************************************************************/

#ifndef _SDIB32GL_H_
#define _SDIB32GL_H_


/* SDib32GL IID's */

#if defined( _WIN32 ) && !defined( _NO_COM )

/* CLSID_SDIB32GLFactory */
/* {F3F74E53-86F0-4263-BC92-10722293A62F} */
DEFINE_GUID( CLSID_SDib32GLFactory, 0xF3F74E53, 0x86F0, 0x4263, 0xBC, 0x92, 0x10, 0x72, 0x22, 0x93, 0xA6, 0x2F);

/* IID_ISDib32GLFactory */
/* {4856FB81-7F22-45c4-B579-33EECEA6DF7E} */
DEFINE_GUID( IID_ISDib32GLFactory, 0x4856FB81, 0x7F22, 0x45c4, 0xB5, 0x79, 0x33, 0xEE, 0xCE, 0xA6, 0xDF, 0x7E);

/* IID_ISDib32GL */
/* {C352C42D-308D-40c0-A2BB-39D729567BC1} */
DEFINE_GUID( IID_ISDib32GL,	0xC352C42D, 0x308D, 0x40c0, 0xA2, 0xBB, 0x39, 0xD7, 0x29, 0x56, 0x7B, 0xC1);

#endif

#ifdef __cplusplus

#ifndef DECLSPEC_UUID
#if _MSC_VER >= 1100
#define DECLSPEC_UUID(x)    __declspec(uuid(x))
#else
#define DECLSPEC_UUID(x)
#endif
#endif

class	  DECLSPEC_UUID( "F3F74E53-86F0-4263-BC92-10722293A62F" ) SDib32GLFactory;
interface DECLSPEC_UUID( "4856FB81-7F22-45c4-B579-33EECEA6DF7E" ) ISDib32GLFactory;
interface DECLSPEC_UUID( "C352C42D-308D-40c0-A2BB-39D729567BC1" ) ISDib32GL;

#if defined(_COM_SMARTPTR_TYPEDEF)

_COM_SMARTPTR_TYPEDEF( ISDib32GLFactory, __uuidof(ISDib32GLFactory));
_COM_SMARTPTR_TYPEDEF( ISDib32GL, __uuidof(ISDib32GL));

#endif
#endif

typedef interface ISDib32GLFactory	ISDib32GLFactory;
typedef interface ISDib32GL			ISDib32GL;


typedef DWORD SDIB32GLCOLOR, *LPSDIB32GLCOLOR;

// SDIB32GLsNZtH[}bg\
typedef union _SDIB32GLARGB {
	struct {
		BYTE Blue;		// vf
		BYTE Green;		// Ηvf
		BYTE Red;		// ԗvf
		BYTE Alpha;		// `l
	};
	SDIB32GLCOLOR Color;	// SĂ̗vf
}SDIB32GLARGB;

typedef enum
{
	SDIB32GLCREATE_AUTO	= 0x000,		// I[g
	SDIB32GLCREATE_X86	= 0x100,		// X86CPU݊
	SDIB32GLCREATE_PMMX	= 0x200,		// Pentium MMX

}SDIB32GLCREATEMODE;

// sN`^Cv
typedef enum
{
	SDIB32GLPICTYPE_BMP = 10,		// rbg}bv
	SDIB32GLPICTYPE_JPG = 20,		// JPEG
	SDIB32GLPICTYPE_PNG = 30,		// PNG
	SDIB32GLPICTYPE_TGA = 40,		// TARGA

}SDIB32GLPICTURETYPE;

// rbg[x
typedef enum
{
	SDIB32GLPICBPP_24 = 30,			// 24rbg
	SDIB32GLPICBPP_32 = 40,			// 32rbg
	
}SDIB32GLBITSPERPIXEL;

// ۑsN`\
typedef struct _SDIB32GLSAVEPICINFO {

	SDIB32GLPICTURETYPE		PicType;			// sN`^Cv
	SDIB32GLBITSPERPIXEL	PicBPP;				// sN`rbg[x
	BOOL					bJPEGProgression;	// JPEGpp[^ - vObVuGR[fBO
	DWORD					dwJPEGQuality;		// JPEGpp[^ - i@1`100
	
}SDIB32GLSAVEPICINFO, *LPSDIB32GLSAVEPICINFO;


// ISDib32GLFactory::EnumBuffers
typedef BOOL (CALLBACK* LPSDIB32GLENUMBUFFERSCALLBACK)(ISDib32GL*, LPARAM);


/* SDib32GLFactory Interface */

#undef INTERFACE
#define INTERFACE ISDib32GLFactory

DECLARE_INTERFACE_( ISDib32GLFactory, IUnknown )
{
	/*** IUnknown methods ***/
	STDMETHOD(QueryInterface)(THIS_ REFIID riid, void** ppvObj) PURE;
	STDMETHOD_(ULONG,AddRef)(THIS) PURE;
	STDMETHOD_(ULONG,Release)(THIS) PURE;

	/*** ISDib32GLFactory methods ***/
	STDMETHOD(Initialize)(THIS_ SDIB32GLCREATEMODE Mode) PURE;
	STDMETHOD(CreateBuffer)(THIS_ long nWidth, long nHeight, SDIB32GLCOLOR FillColor, HDC hDC, ISDib32GL** ppRet) PURE;
	STDMETHOD(CreateBufferFromFile)(THIS_ const BSTR bstrFileName, long nOffset, const BSTR bstrSpiDir, SDIB32GLCOLOR ColorKey, HDC hDC, ISDib32GL** ppRet) PURE;
	STDMETHOD(CreateBufferFromMemory)(THIS_ const void* pvMemory, long nSize, const BSTR bstrSpiDir, SDIB32GLCOLOR ColorKey, HDC hDC, ISDib32GL** ppRet) PURE;
	STDMETHOD(CreateBufferFromResource)(THIS_ HINSTANCE hInstance, const BSTR bstrBitmapID, SDIB32GLCOLOR ColorKey, HDC hDC, ISDib32GL** ppRet) PURE;
	STDMETHOD(DuplicateBuffer)(THIS_ ISDib32GL* pOriginal, ISDib32GL** ppRet) PURE;
	STDMETHOD(GetUseSysMem)(THIS_ LPDWORD lpdwUse) PURE;
	STDMETHOD(GetBufferCount)(THIS_ LPDWORD lpdwCount) PURE;
	STDMETHOD(EnumBuffers)(THIS_ LPSDIB32GLENUMBUFFERSCALLBACK lpEnumBuffersCallback, LPARAM lParam) PURE;
};

typedef struct ISDib32GLFactory *LPSDIB32GLFACTORY, *PSDIB32GLFACTORY;

#if !defined(__cplusplus) || defined(CINTERFACE)
#define ISDib32GLFactory_QueryInterface(p,a,b) (p)->lpVtbl->QueryInterface(p,a,b)
#define ISDib32GLFactory_AddRef(p) (p)->lpVtbl->AddRef(p)
#define ISDib32GLFactory_Release(p) (p)->lpVtbl->Release(p)
#define ISDib32GLFactory_Initialize(p,a) (p)->lpVtbl->Initialize(p,a)
#define ISDib32GLFactory_CreateBuffer(p,a,b,c,d,e) (p)->lpVtbl->CreateBuffer(p,a,b,c,d,e)
#define ISDib32GLFactory_CreateBufferFromFile(p,a,b,c,d,e,f) (p)->lpVtbl->CreateBufferFromFile(p,a,b,c,d,e,f)
#define ISDib32GLFactory_CreateBufferFromMemory(p,a,b,c,d,e,f) (p)->lpVtbl->CreateBufferFromMemory(p,a,b,c,d,e,f)
#define ISDib32GLFactory_CreateBufferFromResource(p,a,b,c,d,e) (p)->lpVtbl->CreateBufferFromResource(p,a,b,c,d,e)
#define ISDib32GLFactory_DuplicateBuffer(p,a,b) (p)->lpVtbl->DuplicateBuffer(p,a,b)
#define ISDib32GLFactory_GetUseSysMem(p,a) (p)->lpVtbl->GetUseSysMem(p,a)
#define ISDib32GLFactory_GetBufferCount(p,a) (p)->lpVtbl->GetBufferCount(p,a)
#define ISDib32GLFactory_EnumBuffers(p,a,b) (p)->lpVtbl->EnumBuffers(p,a,b)
#else
#define ISDib32GLFactory_QueryInterface(p,a,b) (p)->QueryInterface(a,b)
#define ISDib32GLFactory_AddRef(p) (p)->AddRef()
#define ISDib32GLFactory_Release(p) (p)->Release()
#define ISDib32GLFactory_Initialize(p) (p)->Initialize(a)
#define ISDib32GLFactory_CreateBuffer(p,a,b,c,d,e) (p)->CreateBuffer(a,b,c,d,e)
#define ISDib32GLFactory_CreateBufferFromFile(p,a,b,c,d,e,f) (p)->CreateBufferFromFile(a,b,c,d,e,f)
#define ISDib32GLFactory_CreateBufferFromMemory(p,a,b,c,d,e,f) (p)->CreateBufferFromMemory(a,b,c,d,e,f)
#define ISDib32GLFactory_CreateBufferFromResource(p,a,b,c,d,e) (p)->CreateBufferFromResource(a,b,c,d,e)
#define ISDib32GLFactory_DuplicateBuffer(p,a,b) (p)->DuplicateBuffer(a,b)
#define ISDib32GLFactory_GetUseSysMem(p,a) (p)->GetUseSysMem(a)
#define ISDib32GLFactory_GetBufferCount(p,a) (p)->GetBufferCount(a)
#define ISDib32GLFactory_EnumBuffers(p,a,b) (p)->EnumBuffers(a,b)
#endif





/* SDib32GL Interface */

#undef INTERFACE
#define INTERFACE ISDib32GL

DECLARE_INTERFACE_( ISDib32GL, IUnknown )
{
	/*** IUnknown methods ***/
	STDMETHOD(QueryInterface)(THIS_ REFIID riid, void** ppvObj) PURE;
	STDMETHOD_(ULONG,AddRef)(THIS) PURE;
	STDMETHOD_(ULONG,Release)(THIS) PURE;

	/*** ISDib32GL methods ***/
	STDMETHOD(SaveAsFile)(THIS_ const BSTR bstrFileName ) PURE;
	STDMETHOD(SaveAsFileEx)(THIS_ const BSTR bstrFileName, const LPSDIB32GLSAVEPICINFO lpPicInfo, LPDWORD lpdwSize) PURE;
	STDMETHOD(Blt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize) PURE;
	STDMETHOD(ColorKeyBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize) PURE;
	STDMETHOD(AlphaBlendBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha) PURE;
	STDMETHOD(ColorKeyAlphaBlendBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha ) PURE;
	STDMETHOD(AddBlendBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize) PURE;
	STDMETHOD(AddAlphaBlendBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha) PURE;
	STDMETHOD(SubBlendBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize) PURE;
	STDMETHOD(SubAlphaBlendBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha) PURE;
	STDMETHOD(AlphaChannelBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize) PURE;
	STDMETHOD(AlphaChannelAlphaBlendBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha) PURE;
	STDMETHOD(AlphaChannelMaskBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize) PURE;
	STDMETHOD(AlphaChannelMaskAlphaBlendBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha) PURE;
	STDMETHOD(RotateBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, long nAngle, LPPOINT lpCenterPt) PURE;
	STDMETHOD(RotateColorKeyBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, long nAngle, LPPOINT lpCenterPt) PURE;
	STDMETHOD(RotateAlphaBlendBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha, long nAngle, LPPOINT lpCenterPt) PURE;
	STDMETHOD(RotateColorKeyAlphaBlendBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha, long nAngle, LPPOINT lpCenterPt) PURE;
	STDMETHOD(RotateAddBlendBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, long nAngle, LPPOINT lpCenterPt) PURE;
	STDMETHOD(RotateAddAlphaBlendBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha, long nAngle, LPPOINT lpCenterPt) PURE;
	STDMETHOD(RotateSubBlendBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, long nAngle, LPPOINT lpCenterPt) PURE;
	STDMETHOD(RotateSubAlphaBlendBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha, long nAngle, LPPOINT lpCenterPt) PURE;
	STDMETHOD(RotateAlphaChannelBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, long nAngle, LPPOINT lpCenterPt) PURE;
	STDMETHOD(RotateAlphaChannelAlphaBlendBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha, long nAngle, LPPOINT lpCenterPt) PURE;
	STDMETHOD(RotateAlphaChannelMaskBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, long nAngle, LPPOINT lpCenterPt) PURE;
	STDMETHOD(RotateAlphaChannelMaskAlphaBlendBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha, long nAngle, LPPOINT lpCenterPt) PURE;
	STDMETHOD(UniversalTransBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, ISDib32GL* lpRuleSDib32GL, WORD wPhase, BYTE Vague, DWORD dwRuleFlags) PURE;
	STDMETHOD(UniversalTransColorKeyBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, ISDib32GL* lpRuleSDib32GL, WORD wPhase, BYTE Vague, DWORD dwRuleFlags) PURE;
	STDMETHOD(UniversalTransAlphaChannelBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, ISDib32GL* lpRuleSDib32GL, WORD wPhase, BYTE Vague, DWORD dwRuleFlags) PURE;
	STDMETHOD(RGBToAlphaBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize) PURE;
	STDMETHOD(RToAlphaBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize) PURE;
	STDMETHOD(GToAlphaBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize) PURE;
	STDMETHOD(BToAlphaBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize) PURE;
	STDMETHOD(AlphaToAlphaBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize) PURE;
	STDMETHOD(ColorKeyToColorBlt)(THIS_ ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, SDIB32GLCOLOR Color) PURE;
	STDMETHOD(ColorKeyToAlpha)(THIS) PURE;
	STDMETHOD(SetColorKey)(THIS_ SDIB32GLCOLOR Color) PURE;
	STDMETHOD(SetClipArea)(THIS_ long nX, long nY, long nW, long nH) PURE;
	STDMETHOD(SetClipRect)(THIS_ LPRECT lprcClipArea) PURE;
	STDMETHOD(GetClipRect)(THIS_ LPRECT lprcClipArea) PURE;
	STDMETHOD(GetSize)(THIS_ LPSIZE lpSize) PURE;
	STDMETHOD(GetWidth)(THIS_ LPDWORD lpdwWidth) PURE;
	STDMETHOD(GetHeight)(THIS_ LPDWORD lpdwHeight) PURE;
	STDMETHOD(GetDC)(THIS_ HDC* lphDC) PURE;
	STDMETHOD(GetBitmap)(THIS_ HBITMAP* lphBitmap) PURE;
	STDMETHOD(GetBits)(THIS_ LPSDIB32GLCOLOR* lplpBits) PURE;
	STDMETHOD(GetScanLine)(THIS_ long nLine, LPSDIB32GLCOLOR* lplpBits) PURE;
	STDMETHOD(GetScanLineBuffer)(THIS_ LPSDIB32GLCOLOR** lplplpScanLine) PURE;
	STDMETHOD(GetColorKey)(THIS_ LPSDIB32GLCOLOR lpColorKey) PURE;
	STDMETHOD(GetPixels)(THIS_ LPDWORD lpdwPixels) PURE;
	STDMETHOD(GetSizeImage)(THIS_ LPDWORD lpdwSizeImamge) PURE;
	STDMETHOD(GetFileName)(THIS_ BSTR* lpbstrFileName) PURE;
	STDMETHOD(SetPixel)(THIS_ long x, long y, SDIB32GLCOLOR Color) PURE;
	STDMETHOD(GetPixel)(THIS_ long x, long y, LPSDIB32GLCOLOR lpColor) PURE;
	STDMETHOD(Draw)(THIS_ HDC hDC ) PURE;
	STDMETHOD(Clear)(THIS_ SDIB32GLCOLOR Color) PURE;
	STDMETHOD(Rectangle)(THIS_ long x, long y, long nWidth, long nHeight, SDIB32GLCOLOR Color) PURE;
	STDMETHOD(RectangleAlpha)(THIS_ long x, long y, long nWidth, long nHeight, SDIB32GLCOLOR Color) PURE;
	STDMETHOD(RectangleAdd)(THIS_ long x, long y, long nWidth, long nHeight, SDIB32GLCOLOR Color) PURE;
	STDMETHOD(RectangleSub)(THIS_ long x, long y, long nWidth, long nHeight, SDIB32GLCOLOR Color) PURE;
	STDMETHOD(Line)(THIS_ long x0, long y0, long x1, long y1, SDIB32GLCOLOR Color) PURE;
	STDMETHOD(LineAlpha)(THIS_ long x0, long y0, long x1, long y1, SDIB32GLCOLOR Color) PURE;
	STDMETHOD(LineAdd)(THIS_ long x0, long y0, long x1, long y1, SDIB32GLCOLOR Color) PURE;
	STDMETHOD(LineSub)(THIS_ long x0, long y0, long x1, long y1, SDIB32GLCOLOR Color) PURE;
	STDMETHOD(Ellipse)(THIS_ long x0, long y0, long rx, long ry, SDIB32GLCOLOR Color) PURE;
	STDMETHOD(EllipseAlpha)(THIS_ long x0, long y0, long rx, long ry, SDIB32GLCOLOR Color) PURE;
	STDMETHOD(EllipseAdd)(THIS_ long x0, long y0, long rx, long ry, SDIB32GLCOLOR Color) PURE;
	STDMETHOD(EllipseSub)(THIS_ long x0, long y0, long rx, long ry, SDIB32GLCOLOR Color) PURE;
	STDMETHOD(Nega)(THIS_ long x, long y, long nWidth, long nHeight) PURE;
	STDMETHOD(Mono)(THIS_ long x, long y, long nWidth, long nHeight, BYTE Strength) PURE;
	STDMETHOD(Sepia)(THIS_ long x, long y, long nWidth, long nHeight, BYTE Strength, SDIB32GLCOLOR Color) PURE;
	STDMETHOD(Bright)(THIS_ long x, long y, long nWidth, long nHeight, long nBright) PURE;
	STDMETHOD(Mosaic)(THIS_ long x, long y, long nWidth, long nHeight, long nBlockWidth, long nBlockHeight) PURE;
};

typedef struct ISDib32GL *LPSDIB32GL, *PSDIB32GL;

#if !defined(__cplusplus) || defined(CINTERFACE)
#define ISDib32GL_QueryInterface(p,a,b) (p)->lpVtbl->QueryInterface(p,a,b)
#define ISDib32GL_AddRef(p) (p)->lpVtbl->AddRef(p)
#define ISDib32GL_Release(p) (p)->lpVtbl->Release(p)
#define ISDib32GL_SaveAsFile(p,a) (p)->lpVtbl->SaveAsFile(p,a)
#define ISDib32GL_SaveAsFileEx(p,a,b,c) (p)->lpVtbl->SaveAsFileEx(p,a,b,c)
#define ISDib32GL_Blt(p,a,b,c,d,e,f) (p)->lpVtbl->Blt(p,a,b,c,d,e,f)
#define ISDib32GL_ColorKeyBlt(p,a,b,c,d,e,f) (p)->lpVtbl->ColorKeyBlt(p,a,b,c,d,e,f)
#define ISDib32GL_AlphaBlendBlt(p,a,b,c,d,e,f,g) (p)->lpVtbl->AlphaBlendBlt(p,a,b,c,d,e,f,g)
#define ISDib32GL_ColorKeyAlphaBlendBlt(p,a,b,c,d,e,f,g) (p)->lpVtbl->ColorKeyAlphaBlendBlt(p,a,b,c,d,e,f,g)
#define ISDib32GL_AddBlendBlt(p,a,b,c,d,e,f) (p)->lpVtbl->AddBlendBlt(p,a,b,c,d,e,f)
#define ISDib32GL_AddAlphaBlendBlt(p,a,b,c,d,e,f,g) (p)->lpVtbl->AddAlphaBlendBlt(p,a,b,c,d,e,f,g)
#define ISDib32GL_SubBlendBlt(p,a,b,c,d,e,f) (p)->lpVtbl->SubBlendBlt(p,a,b,c,d,e,f)
#define ISDib32GL_SubAlphaBlendBlt(p,a,b,c,d,e,f,g) (p)->lpVtbl->SubAlphaBlendBlt(p,a,b,c,d,e,f,g)
#define ISDib32GL_AlphaChannelBlt(p,a,b,c,d,e,f) (p)->lpVtbl->AlphaChannelBlt(p,a,b,c,d,e,f)
#define ISDib32GL_AlphaChannelAlphaBlendBlt(p,a,b,c,d,e,f,g) (p)->lpVtbl->AlphaChannelAlphaBlendBlt(p,a,b,c,d,e,f,g)
#define ISDib32GL_AlphaChannelMaskBlt(p,a,b,c,d,e,f) (p)->lpVtbl->AlphaChannelMaskBlt(p,a,b,c,d,e,f)
#define ISDib32GL_AlphaChannelMaskAlphaBlendBlt(p,a,b,c,d,e,f,g) (p)->lpVtbl->AlphaChannelMaskAlphaBlendBlt(p,a,b,c,d,e,f,g)
#define ISDib32GL_RotateBlt(p,a,b,c,d,e,f,g,h) (p)->lpVtbl->RotateBlt(p,a,b,c,d,e,f,g,h)
#define ISDib32GL_RotateColorKeyBlt(p,a,b,c,d,e,f,g,h) (p)->lpVtbl->RotateColorKeyBlt(p,a,b,c,d,e,f,g,h)
#define ISDib32GL_RotateAlphaBlendBlt(p,a,b,c,d,e,f,g,h,i) (p)->lpVtbl->RotateAlphaBlendBlt(p,a,b,c,d,e,f,g,h,i)
#define ISDib32GL_RotateColorKeyAlphaBlendBlt(p,a,b,c,d,e,f,g,h,i) (p)->lpVtbl->RotateColorKeyAlphaBlendBlt(p,a,b,c,d,e,f,g,h,i)
#define ISDib32GL_RotateAddBlendBlt(p,a,b,c,d,e,f,g,h) (p)->lpVtbl->RotateAddBlendBlt(p,a,b,c,d,e,f,g,h)
#define ISDib32GL_RotateAddAlphaBlendBlt(p,a,b,c,d,e,f,g,h,i) (p)->lpVtbl->RotateAddAlphaBlendBlt(p,a,b,c,d,e,f,g,h,i)
#define ISDib32GL_RotateSubBlendBlt(p,a,b,c,d,e,f,g,h) (p)->lpVtbl->RotateSubBlendBlt(p,a,b,c,d,e,f,g,h)
#define ISDib32GL_RotateSubAlphaBlendBlt(p,a,b,c,d,e,f,g,h,i) (p)->lpVtbl->RotateSubAlphaBlendBlt(p,a,b,c,d,e,f,g,h,i)
#define ISDib32GL_RotateAlphaChannelBlt(p,a,b,c,d,e,f,g,h) (p)->lpVtbl->RotateAlphaChannelBlt(p,a,b,c,d,e,f,g,h)
#define ISDib32GL_RotateAlphaChannelAlphaBlendBlt(p,a,b,c,d,e,f,g,h,i) (p)->lpVtbl->RotateAlphaChannelAlphaBlendBlt(p,a,b,c,d,e,f,g,h,i)
#define ISDib32GL_RotateAlphaChannelMaskBlt(p,a,b,c,d,e,f,g,h) (p)->lpVtbl->RotateAlphaChannelMaskBlt(p,a,b,c,d,e,f,g,h)
#define ISDib32GL_RotateAlphaChannelMaskAlphaBlendBlt(p,a,b,c,d,e,f,g,h,i) (p)->lpVtbl->RotateAlphaChannelMaskAlphaBlendBlt(p,a,b,c,d,e,f,g,h,i)
#define ISDib32GL_UniversalTransBlt(p,a,b,c,d,e,f,g,h,i,j) (p)->lpVtbl->UniversalTransBlt(p,a,b,c,d,e,f,g,h,i,j)
#define ISDib32GL_UniversalTransColorKeyBlt(p,a,b,c,d,e,f,g,h,i,j) (p)->lpVtbl->UniversalTransColorKeyBlt(p,a,b,c,d,e,f,g,h,i,j)
#define ISDib32GL_UniversalTransAlphaChannelBlt(p,a,b,c,d,e,f,g,h,i,j) (p)->lpVtbl->UniversalTransAlphaChannelBlt(p,a,b,c,d,e,f,g,h,i,j)
#define ISDib32GL_RGBToAlphaBlt(p,a,b,c,d,e,f) (p)->lpVtbl->RGBToAlphaBlt(p,a,b,c,d,e,f)
#define ISDib32GL_RToAlphaBlt(p,a,b,c,d,e,f) (p)->lpVtbl->RToAlphaBlt(p,a,b,c,d,e,f)
#define ISDib32GL_GToAlphaBlt(p,a,b,c,d,e,f) (p)->lpVtbl->GToAlphaBlt(p,a,b,c,d,e,f)
#define ISDib32GL_BToAlphaBlt(p,a,b,c,d,e,f) (p)->lpVtbl->BToAlphaBlt(p,a,b,c,d,e,f)
#define ISDib32GL_AlphaToAlphaBlt(p,a,b,c,d,e,f) (p)->lpVtbl->AlphaToAlphaBlt(p,a,b,c,d,e,f)
#define ISDib32GL_ColorKeyToColorBlt(p,a,b,c,d,e,f,g) (p)->lpVtbl->ColorKeyToColorBlt(p,a,b,c,d,e,f,g)
#define ISDib32GL_ColorKeyToAlpha(p) (p)->lpVtbl->ColorKeyToAlpha(p)
#define ISDib32GL_SetColorKey(p,b) (p)->lpVtbl->SetColorKey(p,a)
#define ISDib32GL_SetClipArea(p,a,b,c,d) (p)->lpVtbl->SetClipArea(p,a,b,c,d)
#define ISDib32GL_SetClipRect(p,a) (p)->lpVtbl->SetClipRect(p,a)
#define ISDib32GL_GetClipRect(p,a) (p)->lpVtbl->GetClipRect(p,a)
#define ISDib32GL_GetSize(p,a) (p)->lpVtbl->GetSize(p,a)
#define ISDib32GL_GetWidth(p,a) (p)->lpVtbl->GetWidth(p,a)
#define ISDib32GL_GetHeight(p,a) (p)->lpVtbl->GetHeight(p,a)
#define ISDib32GL_GetDC(p,a) (p)->lpVtbl->GetDC(p,a)
#define ISDib32GL_GetBitmap(p,a) (p)->lpVtbl->GetBitmap(p,a)
#define ISDib32GL_GetBits(p,a) (p)->lpVtbl->GetBits(p,a)
#define ISDib32GL_GetScanLine(p,a,b) (p)->lpVtbl->GetScanLine(p,a,b)
#define ISDib32GL_GetScanLineBuffer(p,a) (p)->lpVtbl->GetScanLineBuffer(p,a)
#define ISDib32GL_GetColorKey(p,a) (p)->lpVtbl->GetColorKey(p,a)
#define ISDib32GL_GetPixels(p,a) (p)->lpVtbl->GetPixels(p,a)
#define ISDib32GL_GetSizeImage(p,a) (p)->lpVtbl->GetSizeImage(p,a)
#define ISDib32GL_GetFileName(p,a) (p)->lpVtbl->GetFileName(p,a)
#define ISDib32GL_SetPixel(p,a,b,c) (p)->lpVtbl->SetPixel(p,a,b,c)
#define ISDib32GL_GetPixel(p,a,b,c) (p)->lpVtbl->GetPixel(p,a,b,c)
#define ISDib32GL_Draw(p,a) (p)->lpVtbl->Draw(p,a)
#define ISDib32GL_Clear(p,a) (p)->lpVtbl->Clear(p,a)
#define ISDib32GL_Rectangle(p,a,b,c,d,e) (p)->lpVtbl->Rectangle(p,a,b,c,d,e)
#define ISDib32GL_RectangleAlpha(p,a,b,c,d,e) (p)->lpVtbl->RectangleAlpha(p,a,b,c,d,e)
#define ISDib32GL_RectangleAdd(p,a,b,c,d,e) (p)->lpVtbl->RectangleAdd(p,a,b,c,d,e)
#define ISDib32GL_RectangleSub(p,a,b,c,d,e) (p)->lpVtbl->RectangleSub(p,a,b,c,d,e)
#define ISDib32GL_Line(p,a,b,c,d,e) (p)->lpVtbl->Line(p,a,b,c,d,e)
#define ISDib32GL_LineAlpha(p,a,b,c,d,e) (p)->lpVtbl->LineAlpha(p,a,b,c,d,e)
#define ISDib32GL_LineAdd(p,a,b,c,d,e) (p)->lpVtbl->LineAdd(p,a,b,c,d,e)
#define ISDib32GL_LineSub(p,a,b,c,d,e) (p)->lpVtbl->LineSub(p,a,b,c,d,e)
#define ISDib32GL_Ellipse(p,a,b,c,d,e) (p)->lpVtbl->Ellipse(p,a,b,c,d,e)
#define ISDib32GL_EllipseAlpha(p,a,b,c,d,e) (p)->lpVtbl->EllipseAlpha(p,a,b,c,d,e)
#define ISDib32GL_EllipseAdd(p,a,b,c,d,e) (p)->lpVtbl->EllipseAdd(p,a,b,c,d,e)
#define ISDib32GL_EllipseSub(p,a,b,c,d,e) (p)->lpVtbl->EllipseSub(p,a,b,c,d,e)
#define ISDib32GL_Nega(p,a,b,c,d) (p)->lpVtbl->Nega(p,a,b,c,d)
#define ISDib32GL_Mono(p,a,b,c,d,e) (p)->lpVtbl->Mono(p,a,b,c,d,e)
#define ISDib32GL_Sepia(p,a,b,c,d,e,f) (p)->lpVtbl->Sepia(p,a,b,c,d,e,f)
#define ISDib32GL_Bright(p,a,b,c,d,e) (p)->lpVtbl->Bright(p,a,b,c,d,e)
#define ISDib32GL_Mosaic(p,a,b,c,d,e,f) (p)->lpVtbl->Mosaic(p,a,b,c,d,e,f)
#else
#define ISDib32GL_QueryInterface(p,a,b) (p)->QueryInterface(a,b)
#define ISDib32GL_AddRef(p) (p)->AddRef()
#define ISDib32GL_Release(p) (p)->Release()
#define ISDib32GL_SaveAsFile(p,a) (p)->SaveAsFile(a)
#define ISDib32GL_SaveAsFileEx(p,a,b,c) (p)->SaveAsFileEx(a,b,c)
#define ISDib32GL_Blt(p,a,b,c,d,e,f) (p)->Blt(a,b,c,d,e,f)
#define ISDib32GL_ColorKeyBlt(p,a,b,c,d,e,f) (p)->ColorKeyBlt(a,b,c,d,e,f)
#define ISDib32GL_AlphaBlendBlt(p,a,b,c,d,e,f,g) (p)->AlphaBlendBlt(a,b,c,d,e,f,g)
#define ISDib32GL_ColorKeyAlphaBlendBlt(p,a,b,c,d,e,f,g) (p)->ColorKeyAlphaBlendBlt(a,b,c,d,e,f,g)
#define ISDib32GL_AddBlendBlt(p,a,b,c,d,e,f) (p)->AddBlendBlt(a,b,c,d,e,f)
#define ISDib32GL_AddAlphaBlendBlt(p,a,b,c,d,e,f,g) (p)->AddAlphaBlendBlt(a,b,c,d,e,f,g)
#define ISDib32GL_SubBlendBlt(p,a,b,c,d,e,f) (p)->SubBlendBlt(a,b,c,d,e,f)
#define ISDib32GL_SubAlphaBlendBlt(p,a,b,c,d,e,f,g) (p)->SubAlphaBlendBlt(a,b,c,d,e,f,g)
#define ISDib32GL_AlphaChannelBlt(p,a,b,c,d,e,f) (p)->AlphaChannelBlt(a,b,c,d,e,f)
#define ISDib32GL_AlphaChannelAlphaBlendBlt(p,a,b,c,d,e,f,g) (p)->AlphaChannelAlphaBlendBlt(a,b,c,d,e,f,g)
#define ISDib32GL_AlphaChannelMaskBlt(p,a,b,c,d,e,f) (p)->AlphaChannelMaskBlt(a,b,c,d,e,f)
#define ISDib32GL_AlphaChannelMaskAlphaBlendBlt(p,a,b,c,d,e,f,g) (p)->AlphaChannelMaskAlphaBlendBlt(a,b,c,d,e,f,g)
#define ISDib32GL_RotateBlt(p,a,b,c,d,e,f,g,h) (p)->RotateBlt(a,b,c,d,e,f,g,h)
#define ISDib32GL_RotateColorKeyBlt(p,a,b,c,d,e,f,g,h) (p)->RotateColorKeyBlt(a,b,c,d,e,f,g,h)
#define ISDib32GL_RotateAlphaBlendBlt(p,a,b,c,d,e,f,g,h,i) (p)->RotateAlphaBlendBlt(a,b,c,d,e,f,g,h,i)
#define ISDib32GL_RotateColorKeyAlphaBlendBlt(p,a,b,c,d,e,f,g,h,i) (p)->RotateColorKeyAlphaBlendBlt(a,b,c,d,e,f,g,h,i)
#define ISDib32GL_RotateAddBlendBlt(p,a,b,c,d,e,f,g,h) (p)->RotateAddBlendBlt(a,b,c,d,e,f,g,h)
#define ISDib32GL_RotateAddAlphaBlendBlt(p,a,b,c,d,e,f,g,h,i) (p)->RotateAddAlphaBlendBlt(a,b,c,d,e,f,g,h,i)
#define ISDib32GL_RotateSubBlendBlt(p,a,b,c,d,e,f,g,h) (p)->RotateSubBlendBlt(a,b,c,d,e,f,g,h)
#define ISDib32GL_RotateSubAlphaBlendBlt(p,a,b,c,d,e,f,g,h,i) (p)->RotateSubAlphaBlendBlt(a,b,c,d,e,f,g,h,i)
#define ISDib32GL_RotateAlphaChannelBlt(p,a,b,c,d,e,f,g,h) (p)->RotateAlphaChannelBlt(a,b,c,d,e,f,g,h)
#define ISDib32GL_RotateAlphaChannelAlphaBlendBlt(p,a,b,c,d,e,f,g,h,i) (p)->RotateAlphaChannelAlphaBlendBlt(a,b,c,d,e,f,g,h,i)
#define ISDib32GL_RotateAlphaChannelMaskBlt(p,a,b,c,d,e,f,g,h) (p)->RotateAlphaChannelMaskBlt(a,b,c,d,e,f,g,h)
#define ISDib32GL_RotateAlphaChannelMaskAlphaBlendBlt(p,a,b,c,d,e,f,g,h,i) (p)->RotateAlphaChannelMaskAlphaBlendBlt(a,b,c,d,e,f,g,h,i)
#define ISDib32GL_UniversalTransBlt(p,a,b,c,d,e,f,g,h,i,j) (p)->UniversalTransBlt(a,b,c,d,e,f,g,h,i,j)
#define ISDib32GL_UniversalTransColorKeyBlt(p,a,b,c,d,e,f,g,h,i,j) (p)->UniversalTransColorKeyBlt(a,b,c,d,e,f,g,h,i,j)
#define ISDib32GL_UniversalTransAlphaChannelBlt(p,a,b,c,d,e,f,g,h,i,j) (p)->UniversalTransAlphaChannelBlt(a,b,c,d,e,f,g,h,i,j)
#define ISDib32GL_RGBToAlphaBlt(p,a,b,c,d,e,f) (p)->RGBToAlphaBlt(a,b,c,d,e,f)
#define ISDib32GL_RToAlphaBlt(p,a,b,c,d,e,f) (p)->RToAlphaBlt(a,b,c,d,e,f)
#define ISDib32GL_GToAlphaBlt(p,a,b,c,d,e,f) (p)->GToAlphaBlt(a,b,c,d,e,f)
#define ISDib32GL_BToAlphaBlt(p,a,b,c,d,e,f) (p)->BToAlphaBlt(a,b,c,d,e,f)
#define ISDib32GL_AlphaToAlphaBlt(p,a,b,c,d,e,f) (p)->AlphaToAlphaBlt(a,b,c,d,e,f)
#define ISDib32GL_ColorKeyToColorBlt(p,a,b,c,d,e,f,g) (p)->ColorKeyToColorBlt(a,b,c,d,e,f,g)
#define ISDib32GL_ColorKeyToAlpha(p) (p)->ColorKeyToAlpha()
#define ISDib32GL_SetColorKey(p,b) (p)->SetColorKey(a)
#define ISDib32GL_SetClipArea(p,a,b,c,d) (p)->SetClipArea(a,b,c,d)
#define ISDib32GL_SetClipRect(p,a) (p)->SetClipRect(a)
#define ISDib32GL_GetClipRect(p,a) (p)->GetClipRect(a)
#define ISDib32GL_GetSize(p,a) (p)->GetSize(a)
#define ISDib32GL_GetWidth(p,a) (p)->GetWidth(a)
#define ISDib32GL_GetHeight(p,a) (p)->GetHeight(a)
#define ISDib32GL_GetDC(p,a) (p)->GetDC(a)
#define ISDib32GL_GetBitmap(p,a) (p)->GetBitmap(a)
#define ISDib32GL_GetBits(p,a) (p)->GetBits(a)
#define ISDib32GL_GetScanLine(p,a,b) (p)->GetScanLine(a,b)
#define ISDib32GL_GetScanLineBuffer(p,a) (p)->GetScanLineBuffer(a)
#define ISDib32GL_GetColorKey(p,a) (p)->GetColorKey(a)
#define ISDib32GL_GetPixels(p,a) (p)->GetPixels(a)
#define ISDib32GL_GetSizeImage(p,a) (p)->GetSizeImage(a)
#define ISDib32GL_GetFileName(p,a) (p)->GetFileName(a)
#define ISDib32GL_SetPixel(p,a,b,c) (p)->SetPixel(a,b,c)
#define ISDib32GL_GetPixel(p,a,b,c) (p)->GetPixel(a,b,c)
#define ISDib32GL_Draw(p,a) (p)->Draw(a)
#define ISDib32GL_Clear(p,a) (p)->Clear(a)
#define ISDib32GL_Rectangle(p,a,b,c,d,e) (p)->Rectangle(a,b,c,d,e)
#define ISDib32GL_RectangleAlpha(p,a,b,c,d,e) (p)->RectangleAlpha(a,b,c,d,e)
#define ISDib32GL_RectangleAdd(p,a,b,c,d,e) (p)->RectangleAdd(a,b,c,d,e)
#define ISDib32GL_RectangleSub(p,a,b,c,d,e) (p)->RectangleSub(a,b,c,d,e)
#define ISDib32GL_Line(p,a,b,c,d,e) (p)->Line(a,b,c,d,e)
#define ISDib32GL_LineAlpha(p,a,b,c,d,e) (p)->LineAlpha(a,b,c,d,e)
#define ISDib32GL_LineAdd(p,a,b,c,d,e) (p)->LineAdd(a,b,c,d,e)
#define ISDib32GL_LineSub(p,a,b,c,d,e) (p)->LineSub(a,b,c,d,e)
#define ISDib32GL_Ellipse(p,a,b,c,d,e) (p)->Ellipse(a,b,c,d,e)
#define ISDib32GL_EllipseAlpha(p,a,b,c,d,e) (p)->EllipseAlpha(a,b,c,d,e)
#define ISDib32GL_EllipseAdd(p,a,b,c,d,e) (p)->EllipseAdd(a,b,c,d,e)
#define ISDib32GL_EllipseSub(p,a,b,c,d,e) (p)->EllipseSub(a,b,c,d,e)
#define ISDib32GL_Nega(p,a,b,c,d) (p)->Nega(a,b,c,d)
#define ISDib32GL_Mono(p,a,b,c,d,e) (p)->Mono(a,b,c,d,e)
#define ISDib32GL_Sepia(p,a,b,c,d,e,f) (p)->Sepia(a,b,c,d,e,f)
#define ISDib32GL_Bright(p,a,b,c,d,e) (p)->Bright(a,b,c,d,e)
#define ISDib32GL_Mosaic(p,a,b,c,d,e,f) (p)->Mosaic(a,b,c,d,e,f)
#endif


/* SDIB32GL Errors */
#define MAKE_SDIB32GLHRESULT( code )			MAKE_HRESULT( SEVERITY_ERROR, FACILITY_ITF, code )
#define MAKE_SDIB32GLSTATUS( code )				MAKE_HRESULT( SEVERITY_SUCCESS, FACILITY_ITF, code )

#define SDIB32GLERR_OUTOFMEMORY					E_OUTOFMEMORY

#define SDIB32GLERR_SDIB32GLALREADYCREATED 		MAKE_SDIB32GLHRESULT(0x200)
#define SDIB32GLERR_DIBNOTCREATED				MAKE_SDIB32GLHRESULT(0x201)
#define SDIB32GLERR_MEMORYDCNOTCREATED			MAKE_SDIB32GLHRESULT(0x202)
#define SDIB32GLERR_FILENOTFOUND				MAKE_SDIB32GLHRESULT(0x203)
#define SDIB32GLERR_FILENOTCREATED				MAKE_SDIB32GLHRESULT(0x204)
#define SDIB32GLERR_NOTINITIALIZED				MAKE_SDIB32GLHRESULT(0x205)
#define SDIB32GLERR_INVALIDOBJECT				MAKE_SDIB32GLHRESULT(0x206)
#define SDIB32GLERR_INVALIDPARAMS				MAKE_SDIB32GLHRESULT(0x207)
#define SDIB32GLERR_UNSUPPORTEDFILE				MAKE_SDIB32GLHRESULT(0x208)
#define SDIB32GLERR_UNSUPPORTEDBITCOUNT			MAKE_SDIB32GLHRESULT(0x209)
#define SDIB32GLERR_UNSUPPORTEDFORMAT			MAKE_SDIB32GLHRESULT(0x30A)
#define SDIB32GLERR_EXCEPTION					MAKE_SDIB32GLHRESULT(0x30B)
#define SDIB32GLERR_ALREADYINITIALIZED			MAKE_SDIB32GLHRESULT(0x30C)

#define SDIB32GLS_ROTATEBLT64BIT				MAKE_SDIB32GLSTATUS(0x1000)
#define SDIB32GLS_INVALIDPOSITION				MAKE_SDIB32GLSTATUS(0x1001)


/* SDIB32GL UTILITY MACROS */
#define SDIB32GLCOLOR_ARGB( a, r, g, b )	((DWORD)((((a)&0xFF)<<24)|(((r)&0xFF)<<16)|(((g)&0xFF)<<8)|((b)&0xFF)))
#define SDIB32GLCOLOR_RGBA( r, g, b, a )	SDIB32GLCOLOR_ARGB( a, r, g, b ) 
#define SDIB32GLCOLOR_XRGB( r, g, b )		SDIB32GLCOLOR_ARGB( 0xFF, r, g, b )
#define SDIB32GLCOLOR_SETRED( r )			SDIB32GLCOLOR_ARGB( 0xFF, r, 0, 0 )
#define SDIB32GLCOLOR_SETGREEN( g )			SDIB32GLCOLOR_ARGB( 0xFF, 0, g, 0 )
#define SDIB32GLCOLOR_SETBLUE( b )			SDIB32GLCOLOR_ARGB( 0xFF, 0, 0, b )
#define SDIB32GLCOLOR_SETALPHA( a )			SDIB32GLCOLOR_ARGB( a, 0xFF, 0xFF, 0xFF )
#define SDIB32GLCOLOR_RGB					SDIB32GLCOLOR_XRGB
#define SDIB32GLCOLOR_GETREVALPHA( argb )	(255-SDIB32GLCOLOR_GETALPHA( argb ))
#define SDIB32GLCOLOR_GETALPHA( argb )		((BYTE)((argb)>>24))
#define SDIB32GLCOLOR_GETRED( argb )		((BYTE)((argb)>>16))
#define SDIB32GLCOLOR_GETGREEN( argb )		((BYTE)((argb)>>8))
#define SDIB32GLCOLOR_GETBLUE( argb )		((BYTE)((argb))) 
#define SDIB32GLCOLOR_WHITE					0xFFFFFFFF
#define SDIB32GLCOLOR_BLACK					0xFF000000
#define SDIB32GLCOLOR_RED					0xFFFF0000
#define SDIB32GLCOLOR_GREEN					0xFF00FF00
#define SDIB32GLCOLOR_BLUE					0xFF0000FF
#define SDIB32GLCOLOR_YELLOW				0xFFFFFF00
#define SDIB32GLCOLOR_CYAN					0xFF00FFFF
#define SDIB32GLCOLOR_MAGENTA				0xFFFF00FF
#define SDIB32GLCOLOR_GRAY					0xFF808080
#define SDIB32GLCOLOR_SEPIA					0xFFF0C891

#define SDIB32GLANGLE_360To512( a )			(((a) << 9 ) / 360 )
#define SDIB32GLANGLE_512To360( a )			(((a) * 360) >> 9 )

#define SDIB32GLRULE_DEFAULT				0x00000000
#define SDIB32GLRULE_MIRRORLEFTRIGHT		0x00000001
#define SDIB32GLRULE_MIRRORUPDOWN			0x00000002


#ifdef __cplusplus
extern "C"
{
#endif


// SDIB32GLFactory쐬API֐(DLLÓINp)
HRESULT
WINAPI
SDIB32GLFactoryCreate(
	const SDIB32GLCREATEMODE Mode,
	LPVOID* lplpSDIB32GLFactory,
	REFIID riid
	);


// SDIB32GLo[W擾API֐
DWORD
WINAPI
SDIB32GLGetVersion( void );


// G[擾API֐
DWORD
WINAPI
SDIB32GLGetErrorText(
	HRESULT hr,
	char* pBuffer,
	int nBufferMax
	);


// MMX`FbNAPI֐
BOOL
WINAPI
SDIB32GLIsMMX( void );


// mۂBSTR
HRESULT
WINAPI
SDIB32GLFreeBSTR(
	BSTR* pbstr
	);


#ifdef __cplusplus
}
#endif


#endif /* _SDIB32GL_H_ */