// Rotate.cpp : AvP[Vp̃Gg |Cg̒`
//

#include "stdafx.h"

#include "SDIB32GL.H"
#include "util.h"
#include <list>
using namespace std;

/*** C^[tFCX̏ ***/
LPSDIB32GLFACTORY	lpSDFactory = NULL;
LPSDIB32GL			lpBack		= NULL;
LPSDIB32GL			lpBg		= NULL;
LPSDIB32GL			lpSprite	= NULL;


typedef struct tagMYOBJ {
	long	x;
	long	y;
	float	cx;
	float	cy;
	float	add_cxy;
	long	alpha;
	long	angle;
	long	dir_ag;
	tagMYOBJ() {
		x = rand()%CLIENT_WIDTH;
		y = rand()%CLIENT_HEIGHT;
		cx = 0.f; cy = 0.f;
		alpha = 255;
		angle = rand()%512;
		dir_ag = -rand()%2|1;
		add_cxy = ((rand()/32767.f*5.f)+1.f);
	}
}MYOBJ;

#define OBJ_TIMING	20
typedef list<MYOBJ>::iterator LOBJIT;

list<MYOBJ> lobj;
long	nObjCounter = 0;


/*----------------------------------------------------------------------------*
|	App
*----------------------------------------------------------------------------*/
BOOL AppInitialize( void )
{
	HRESULT hr;

	try
	{
		// t@NgC^[tFCX擾
		hr = SDIB32GLFactoryCreate( 
			SDIB32GLCREATE_AUTO, (void**)&lpSDFactory, IID_ISDib32GLFactory );

		if( FAILED( hr ) )
		{
			throw exception("t@NgC^[tFCXs");
		}

		// NCAg̈TCỸobNobt@쐬
		hr = lpSDFactory->CreateBuffer(
			CLIENT_WIDTH, CLIENT_HEIGHT, 0, NULL, &lpBack );

		if( FAILED( hr ) )
		{
			throw exception("obNobt@̍쐬Ɏs");
		}

		// BGǂݍ
		hr = lpSDFactory->CreateBufferFromFile(
			MEDIAPATH( OLESTR("BackGround.bmp") ), 0, NULL, 0, NULL, &lpBg );

		if( FAILED( hr ) )
		{
			throw exception("t@C̓ǂݍ݂Ɏs");
		}

		// XvCgǂݍ
		hr = lpSDFactory->CreateBufferFromFile(
			MEDIAPATH( OLESTR("Rotate.bmp") ), 0, NULL, SDIB32GLCOLOR_RGB(255,0,255), NULL, &lpSprite );

		if( FAILED( hr ) )
		{
			throw exception("t@C̓ǂݍ݂Ɏs");
		}

	}


	// G[
	catch( exception& e )
	{
		
		MessageBox( hWnd, e.what(), szTitle, MB_OK | MB_ICONSTOP );

		// N[Abv
		AppCleanUp();

		return FALSE;
	}


	SetTextMode( lpBack );

	RANDOMIZE;

	return TRUE;
}


/*----------------------------------------------------------------------------*
|	AppACh
*----------------------------------------------------------------------------*/
void AppIdle( void )
{

	lpBack->Blt( lpBg, 0, 0, NULL, NULL, NULL );

	// IuWFNg̐
	if( nObjCounter == 0 )
	{
		lobj.push_back( MYOBJ() );
	}
	
	// XvCgg~[]
	SIZE size;

	for( LOBJIT it = lobj.begin(); it != lobj.end(); )
	{
		it->alpha -= 2;

		if( it->alpha < 0 )
		{
			it = lobj.erase( it );
			continue;
		}
		
		it->angle += it->dir_ag*2;
		it->cx += it->add_cxy;
		it->cy += it->add_cxy;

		size.cx = (long)it->cx;
		size.cy = (long)it->cy;

		lpBack->RotateColorKeyAlphaBlendBlt( 
			lpSprite, it->x-(size.cx>>1), it->y-(size.cy>>1), 
			&size, NULL, NULL, it->alpha, it->angle, NULL );

		it++;
	}

	++nObjCounter %= OBJ_TIMING;

	// ̕`
	DrawInfo( lpBack );


	// ĕ`
	//*
	HDC hDC = GetDC( hWnd );
	lpBack->Draw( hDC );
	ReleaseDC( hWnd, hDC );
	/*/
	InvalidateRect( hWnd, NULL, FALSE );
	UpdateWindow( hWnd );
	//*/
}


/*----------------------------------------------------------------------------*
|	AppN[Abv
*----------------------------------------------------------------------------*/
void AppCleanUp( void )
{
	SAFE_RELEASE( lpSprite );
	SAFE_RELEASE( lpBg );
	SAFE_RELEASE( lpBack );
	SAFE_RELEASE( lpSDFactory );
}


/*----------------------------------------------------------------------------*
|	WM_PAINT
*----------------------------------------------------------------------------*/
void OnPaint( HDC hdc )
{
	if( lpBack == NULL ) return;

	lpBack->Draw( hdc );
}


