unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Util, AppEvnts, SDIB32GL_TLB, SDIB32GLAPI, ActiveX, ComObj;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    { Private 錾 }
    procedure AppInitialize;
    procedure AppIdle(Sender: TObject; var Done: Boolean);

  public
    { Public 錾 }
  end;

  MYOBJ = record
     x: Integer;
     y: Integer;
     dir_x: Integer;
     dir_y: Integer;
  end;

const MAX_OBJ = 4;

var
  Form1: TForm1;
  Event: TApplicationEvents;
  SDFactory: ISDib32GLFactory;
  Back: ISDib32GL;
  Bg: ISDib32GL;
  Sprite: ISDib32GL;
  obj: array[0..MAX_OBJ-1] of MYOBJ;
  obj_max_x: Integer;
  obj_max_y: Integer;

implementation

{$R *.dfm}


//-----------------------------------------------------------------------------
//   tH[쐬
//-----------------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin

    FormInitialize( Self );

    AppInitialize();

    Event := TApplicationEvents.Create( Self );
    Event.OnIdle := AppIdle;

end;


//-----------------------------------------------------------------------------
//   AppACh
//-----------------------------------------------------------------------------
procedure TForm1.AppIdle(Sender: TObject; var Done: Boolean );
var
    BgSize: SIZE;
    SpSize: SIZE;
    i: Integer;
begin

    Fps.WaitFrame();

    Bg.GetSize( BgSize );
    Sprite.GetSize( SpSize );

    // BG`
    Back.Blt( Bg, 0, 0, BgSize, ZeroPos, BgSize );

    // XvCg`
    for i := 0 to MAX_OBJ-1 do
    begin

        obj[i].x := obj[i].x + obj[i].dir_x*2;
        obj[i].y := obj[i].y + obj[i].dir_y*2;

        if( obj[i].x < 0 ) then
        begin
            obj[i].x := 0;
            obj[i].dir_x := -obj[i].dir_x;
        end
        else if( obj[i].x > obj_max_x ) then
        begin
            obj[i].x := obj_max_x;
            obj[i].dir_x := -obj[i].dir_x;
        end;

        if( obj[i].y < 0 ) then
        begin
            obj[i].y := 0;
            obj[i].dir_y := -obj[i].dir_y;
        end
        else if( obj[i].y > obj_max_y ) then
        begin
            obj[i].y := obj_max_y;
            obj[i].dir_y := -obj[i].dir_y;
        end;

        Back.ColorKeyBlt(Sprite, obj[i].x, obj[i].y, SpSize, ZeroPos, SpSize );
    end;

    // `
    DrawInfo( Back );

    // tH[ɕ`
    //(*
    Back.Draw( Canvas.Handle );
    (*)
    InvalidateRect(Handle, nil, FALSE );
    UpdateWindow(Handle);
    //*)
    Done := false;
end;


//-----------------------------------------------------------------------------
//   App
//-----------------------------------------------------------------------------
procedure TForm1.AppInitialize;
var
    hr: HResult;
    i: Integer;
    SpSize: SIZE;
begin

    try
        // t@NgC^[tFCX擾
        SDFactory := CreateComObject( CLASS_SDib32GLFactory ) as ISDib32GLFactory;

        // t@Ng̏
        hr := SDFactory.Initialize( SDIB32GLCREATE_AUTO );

        if( FAILED(hr) ) then
            raise Exception.Create('t@Ng̏Ɏs');

        // NCAg̈TCỸobNobt@쐬
        hr := SDFactory.CreateBuffer( ClientWidth, ClientHeight, 0, 0, Back );

        if( FAILED(hr) ) then
            raise Exception.Create('obNobt@̍쐬Ɏs');

        // BGǂݍ
        hr := SDFactory.CreateBufferFromFile(
            MediaPath('BackGround.bmp'), 0, '', 0, 0, Bg );

        if( FAILED(hr) ) then
            raise Exception.Create('t@C̓ǂݍ݂Ɏs');

        // XvCgǂݍ
        hr := SDFactory.CreateBufferFromFile(
            MediaPath('ColorKey.bmp'), 0, '',
            SDIB32GLCOLOR_RGB(0,255,0), 0, Sprite );

        if( FAILED(hr) ) then
            raise Exception.Create('t@C̓ǂݍ݂Ɏs');

        SetTextMode( Back );

        Randomize();

        Sprite.GetSize( SpSize );

        obj_max_x := ClientWidth-SpSize.cx;
        obj_max_y := ClientHeight-SpSize.cy;

        for i := 0 to MAX_OBJ-1 do
        begin
            obj[i].x := Random( obj_max_x );
            obj[i].y := Random( obj_max_y );
            obj[i].dir_x := -Random(2) or 1;
            obj[i].dir_y := -Random(2) or 1;
        end;

        Application.ShowMainForm  :=  true;
    except
        on E: Exception do
        begin
            MessageBox(Handle, pchar(E.Message), pchar(Caption), MB_OK or MB_ICONSTOP );
            Application.Terminate;
        end
    end;

end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
    // IuWFNg𖾎Iɉɂ
    // C^[tFCXnil
	{
	Sprite := nil;
	Bg := nil;
	Back := nil;
	SDFactory := nil;
//  }
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
    if( Assigned(Back) ) then

        Back.Draw( Canvas.Handle );
end;

end.
