unit Util;

interface

uses Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, AppEvnts, FpsTimer, SDIB32GL_TLB, SDIB32GLAPI;

const
    CLIENT_WIDTH = 640;
    CLIENT_HEIGHT = 480;
    NULL = nil;
    
  procedure FormInitialize( Form: TForm );
  procedure SetTextMode( Back: ISDib32GL );
  procedure DrawInfo( Back: ISDib32GL );
  function MediaPath( fname: widestring ): widestring;

var
  Fps: TFpsTimer;
  ZeroPos : POINT = ( x: 0; y: 0 );

implementation


//-----------------------------------------------------------------------------
//   tH[
//-----------------------------------------------------------------------------
procedure FormInitialize( Form: TForm );
begin
    Application.ShowMainForm  :=  false;

    // ^Cgݒ
    Form.Caption := ChangeFileExt(
        ExtractFileName( Application.ExeName ), '' );

    // EBhEZ^[
    Form.Position := poDesktopCenter;

    // X^C̐ݒ
    Form.BorderStyle := bsSingle;
    Form.BorderIcons := Form.BorderIcons - [biMaximize];

    // NCAg̈̐ݒ
    Form.ClientWidth := CLIENT_WIDTH;
    Form.ClientHeight := CLIENT_HEIGHT;

end;


//-----------------------------------------------------------------------------
//   eLXg[hݒ
//-----------------------------------------------------------------------------
procedure SetTextMode( Back: ISDib32GL );
var
    hBackDC: HDC;
begin

    Back.GetDC( Integer(hBackDC) );

    SetBkMode( hBackDC, TRANSPARENT );

    SetTextColor( hBackDC, RGB(255,0,0));
end;


//-----------------------------------------------------------------------------
//   ̕`
//-----------------------------------------------------------------------------
procedure DrawInfo( Back: ISDib32GL );
var
    strBuf: string;
    strbMMX: string;
    hBackDC: HDC;
begin

    if( Boolean(SDIB32GLIsMMX()) ) then
        strbMMX := 'YES'
    else strbMMX := 'NO';


    strBuf := FloatToStrF( Fps.GetFPS(), ffNumber, 7, 2 )+'fps'+
                ' UseMMX='+strbMMX+' Ver'+
                FloatToStrF( SDIB32GLGetVersion()/100, ffNumber, 7, 2);

    Back.GetDC( Integer(hBackDC) );

    TextOut( hBackDC, 0, 0, pchar(strBuf), Length(strBuf));
end;


//-----------------------------------------------------------------------------
//   fBApX쐬
//-----------------------------------------------------------------------------
function MediaPath( fname: widestring ): widestring;
begin

    result := '../../Media/'+fname;

end;


initialization

    Fps := TFpsTimer.Create;

finalization

    Fps.Free;
    
end.
