
/******************************************************************************
*	Graphic Saver Class Source
******************************************************************************/

#include "stdafx.h"
#include "GraphicSaver.h"
#ifdef SLIB_USE_GRAPHICSAVER
using namespace selna;


/*----------------------------------------------------------------------------*
|	RXgN^
*----------------------------------------------------------------------------*/
CGraphicSaver::CGraphicSaver()
{
}


/*----------------------------------------------------------------------------*
|	fXgN^
*----------------------------------------------------------------------------*/
CGraphicSaver::~CGraphicSaver()
{
}


/*----------------------------------------------------------------------------*
|	sN`ۑ (t@CNXQƁAC[W\)
*----------------------------------------------------------------------------*/
DWORD CGraphicSaver::SavePicture( CFile& fout, const LPGSPICTUREINFO lpPicInfo, const LPGSIMAGEINFO lpImgInfo )
{
	if( !fout ) return 0;
	if( lpPicInfo == NULL ) return 0;
	if( lpImgInfo == NULL ) return 0;
	if( lpImgInfo->lpBits == NULL ) return 0;

	// sN`ŃT|[go̓rbg[x`FbN
	switch( lpPicInfo->PicType )
	{
	case GSPICTYPE_BMP:	// BITMAP(8,24,32)
		
		if( lpPicInfo->PicBPP == GSPICBPP_8  ) break;
		if( lpPicInfo->PicBPP == GSPICBPP_24 ) break;
		if( lpPicInfo->PicBPP == GSPICBPP_32 ) break;

		return 0;
	case GSPICTYPE_JPG:	// JPEG(24)
		
		if( lpPicInfo->PicBPP == GSPICBPP_24 ) break;
		
		return 0;
	case GSPICTYPE_PNG:	// PNG(8,24,32)

		if( lpPicInfo->PicBPP == GSPICBPP_8  ) break;
		if( lpPicInfo->PicBPP == GSPICBPP_24 ) break;
		if( lpPicInfo->PicBPP == GSPICBPP_32 ) break;

		return 0;
	case GSPICTYPE_TGA:	// TARGA(8,24,32)

		if( lpPicInfo->PicBPP == GSPICBPP_8  ) break;
		if( lpPicInfo->PicBPP == GSPICBPP_24 ) break;
		if( lpPicInfo->PicBPP == GSPICBPP_32 ) break;

		return 0;
	default:

		return 0;
	}

	// XLCobt@쐬
	shared_array<LPBYTE> ppScanLine( new LPBYTE[ abs(lpImgInfo->nHeight) ] );
	LPBYTE pBits = (LPBYTE)lpImgInfo->lpBits;

	if( lpImgInfo->nHeight < 0 )
	{
		lpImgInfo->nHeight = -lpImgInfo->nHeight;

		// gbv_E{gAbv
		for( int h = lpImgInfo->nHeight-1; h >= 0; h-- )
		{
			ppScanLine[ h ] = pBits;
			pBits += lpImgInfo->dwRowBytes;
		}

	}else
	{
		// {gAbv{gAbv
		for( int h = 0; h < lpImgInfo->nHeight; h++ )
		{
			ppScanLine[ h ] = pBits;
			pBits += lpImgInfo->dwRowBytes;
		}
	}

	GSIMAGEINFO NewImgInfo;

	// sNZϊ
	if( !ConvertPixel( lpPicInfo, lpImgInfo, ppScanLine, &NewImgInfo ) ) return 0;

	// ppScanLine.reset();

	// ݂̃t@C|WV擾
	DWORD dwPos = fout.GetPosition();

	// sNZC[WesN`t@Cɂĕۑ
	switch( lpPicInfo->PicType )
	{
	case GSPICTYPE_BMP:	// BITMAP
		
		SaveBitmap( fout, &NewImgInfo );
		break;
	case GSPICTYPE_JPG:	// JPEG

		SaveJpeg( fout, &NewImgInfo, lpPicInfo->bJPEGProgression, lpPicInfo->dwJPEGQuality );
		break;
	case GSPICTYPE_PNG:	// PNG

		SavePng( fout, &NewImgInfo );
		break;
	case GSPICTYPE_TGA:	// TARGA

		SaveTarga( fout, &NewImgInfo );
		break;
	}

	// 
	SAFE_DELETE_ARRAY( NewImgInfo.lpBits );

	// 񂾃TCYԂ
	return fout.GetPosition()-dwPos;
}


/*----------------------------------------------------------------------------*
|	sN`ۑ (t@CNXQƁAC[W)
*----------------------------------------------------------------------------*/
DWORD CGraphicSaver::SavePicture( CFile& fout, GSPICTURETYPE PicType, GSPICTUREBITSPERPIXEL PicBPP, BOOL bJPEGProgression, DWORD dwJPEGQuality, LPVOID lpBits, DWORD dwSize, DWORD dwRowBytes, LONG nWidth, LONG nHeight, GSFORMAT Format, LPRGBQUAD lpPalette )
{

	GSIMAGEINFO		ImgInfo;
	GSPICTUREINFO	PicInfo;

	ImgInfo.lpBits		= lpBits;
	ImgInfo.dwSize		= dwSize;
	ImgInfo.dwRowBytes	= dwRowBytes;
	ImgInfo.nWidth		= nWidth;
	ImgInfo.nHeight		= nHeight;
	ImgInfo.Format		= Format;
	ImgInfo.lpPalette	= lpPalette;

	PicInfo.PicType			 = PicType;
	PicInfo.PicBPP			 = PicBPP;
	PicInfo.bJPEGProgression = bJPEGProgression;
	PicInfo.dwJPEGQuality	 = dwJPEGQuality;

	return SavePicture( fout, &PicInfo, &ImgInfo );
}


/*----------------------------------------------------------------------------*
|	sN`ۑ (t@CAC[W)
*----------------------------------------------------------------------------*/
DWORD CGraphicSaver::SavePicture( const char* lpszFileName, GSPICTURETYPE PicType, GSPICTUREBITSPERPIXEL PicBPP, BOOL bJPEGProgression, DWORD dwJPEGQuality, LPVOID lpBits, DWORD dwSize, DWORD dwRowBytes, LONG nWidth, LONG nHeight, GSFORMAT Format, LPRGBQUAD lpPalette )
{
	CFile fout( lpszFileName, "wb" );
	
	GSIMAGEINFO		ImgInfo;
	GSPICTUREINFO	PicInfo;

	ImgInfo.lpBits		= lpBits;
	ImgInfo.dwSize		= dwSize;
	ImgInfo.dwRowBytes	= dwRowBytes;
	ImgInfo.nWidth		= nWidth;
	ImgInfo.nHeight		= nHeight;
	ImgInfo.Format		= Format;
	ImgInfo.lpPalette	= lpPalette;

	PicInfo.PicType			 = PicType;
	PicInfo.PicBPP			 = PicBPP;
	PicInfo.bJPEGProgression = bJPEGProgression;
	PicInfo.dwJPEGQuality	 = dwJPEGQuality;

	return SavePicture( fout, &PicInfo, &ImgInfo );
}


/*----------------------------------------------------------------------------*
|	sN`ۑ (t@CAC[W\)
*----------------------------------------------------------------------------*/
DWORD CGraphicSaver::SavePicture( const char* lpszFileName, const LPGSPICTUREINFO lpPicInfo, const LPGSIMAGEINFO lpImgInfo )
{
	CFile fout( lpszFileName, "wb" );
	
	return SavePicture( fout, lpPicInfo, lpImgInfo );
}


/*----------------------------------------------------------------------------*
|	sNZϊ
*----------------------------------------------------------------------------*/
bool CGraphicSaver::ConvertPixel( const LPGSPICTUREINFO lpPicInfo, const LPGSIMAGEINFO lpImgInfo, /*const LPBYTE* ppScanLine*/const shared_array<LPBYTE> ppScanLine, LPGSIMAGEINFO lpNewImgInfo )
{
	bool ret = true;

	// 
	::ZeroMemory( lpNewImgInfo, sizeof(GSIMAGEINFO) );
	lpNewImgInfo->nWidth  = lpImgInfo->nWidth;
	lpNewImgInfo->nHeight = lpImgInfo->nHeight;

	int w, h;
	BYTE* pBits;

	// esNZɕϊ
	switch( lpPicInfo->PicBPP )
	{
	case GSPICBPP_8:	// 8rbgsN`(BMP,PNG,TGA)

		if( !lpImgInfo->lpPalette )
		{
			ret = false;
			break;
		}

		lpNewImgInfo->dwRowBytes = GS_GETBMPROWBYTES( lpNewImgInfo->nWidth, 1 );
		lpNewImgInfo->dwSize	 = lpNewImgInfo->dwRowBytes*lpNewImgInfo->nHeight;
		lpNewImgInfo->Format     = GSFMT_P8;
		lpNewImgInfo->lpPalette  = lpImgInfo->lpPalette;
		lpNewImgInfo->lpBits     = new BYTE[ lpNewImgInfo->dwSize ];
		pBits = (LPBYTE)lpNewImgInfo->lpBits;

		if( lpImgInfo->Format == GSFMT_P8 )
		{
			for( h = 0; h < lpNewImgInfo->nHeight; h++ )
			{
				// ̂܂܃Rs[
				::memmove( pBits, ppScanLine[h], lpNewImgInfo->dwRowBytes );

				// 4oCgE̎coCg0Ŗ߂
				::memset( &pBits[lpNewImgInfo->nWidth], 0, lpNewImgInfo->dwRowBytes-lpNewImgInfo->nWidth );

				pBits += lpNewImgInfo->dwRowBytes;
			}

		}else
		{
			SAFE_DELETE_ARRAY( lpNewImgInfo->lpBits );
			ret = false;
		}

		break;
	case GSPICBPP_24:	// 24rbgsN`(BMP,JPG,PNG,TGA)

		lpNewImgInfo->dwRowBytes = GS_GETBMPROWBYTES( lpNewImgInfo->nWidth, 3 );
		lpNewImgInfo->dwSize	 = lpNewImgInfo->dwRowBytes*lpNewImgInfo->nHeight;
		lpNewImgInfo->Format     = GSFMT_R8G8B8;
		lpNewImgInfo->lpBits     = new BYTE[ lpNewImgInfo->dwSize ];
		pBits = (LPBYTE)lpNewImgInfo->lpBits;

		switch( lpImgInfo->Format )
		{
		case GSFMT_R8G8B8:		// 24rbg
			{
				DWORD dwPixelByte = lpNewImgInfo->nWidth*3;

				for( h = 0; h < lpNewImgInfo->nHeight; h++ )
				{
					// ̂܂܃Rs[
					::memmove( pBits, ppScanLine[h], lpNewImgInfo->dwRowBytes );

					// 4oCgE̎coCg0Ŗ߂
					::memset( &pBits[dwPixelByte], 0, lpNewImgInfo->dwRowBytes-dwPixelByte );

					pBits += lpNewImgInfo->dwRowBytes;
				}
			}
			break;
		case GSFMT_X8R8G8B8:	// 32rbg
		case GSFMT_A8R8G8B8:

			for( h = 0; h < lpNewImgInfo->nHeight; h++ )
			{
				int d = 0;
				int s = 0;

				for( w = 0; w < lpNewImgInfo->nWidth; w++ )
				{
					::memmove( &pBits[d], &ppScanLine[h][s], 3 );
					d+=3;
					s+=4;
				}

				// 4oCgE̎coCg0Ŗ߂
				::memset( &pBits[d], 0, lpNewImgInfo->dwRowBytes-d );

				pBits += lpNewImgInfo->dwRowBytes;
			}

			break;
		case GSFMT_R5G6B5:		// 16rbg 565
			{
				GS_INIT_565TABLE();

				for( h = 0; h < lpNewImgInfo->nHeight; h++ )
				{
					WORD* pSrcBits = (WORD*)ppScanLine[h];
					int d = 0;

					for( w = 0; w < lpNewImgInfo->nWidth; w++ )
					{
						pBits[d+0] = GS_R5G6B5ToB8(pSrcBits[w]);
						pBits[d+1] = GS_R5G6B5ToG8(pSrcBits[w]);
						pBits[d+2] = GS_R5G6B5ToR8(pSrcBits[w]);
						d+=3;
					}

					// 4oCgE̎coCg0Ŗ߂
					::memset( &pBits[d], 0, lpNewImgInfo->dwRowBytes-d );

					pBits += lpNewImgInfo->dwRowBytes;
			}
			}
			break;
		case GSFMT_X1R5G5B5:	// 16rbg 555
		case GSFMT_A1R5G5B5:
			{
				GS_INIT_555TABLE();

				for( h = 0; h < lpNewImgInfo->nHeight; h++ )
				{
					WORD* pSrcBits = (WORD*)ppScanLine[h];
					int d = 0;

					for( w = 0; w < lpNewImgInfo->nWidth; w++ )
					{
						pBits[d+0] = GS_A1R5G5B5ToB8(pSrcBits[w]);
						pBits[d+1] = GS_A1R5G5B5ToG8(pSrcBits[w]);
						pBits[d+2] = GS_A1R5G5B5ToR8(pSrcBits[w]);
						d+=3;
					}

					// 4oCgE̎coCg0Ŗ߂
					::memset( &pBits[d], 0, lpNewImgInfo->dwRowBytes-d );

					pBits += lpNewImgInfo->dwRowBytes;
				}
			}
			break;
		case GSFMT_X4R4G4B4:	// 16rbg 444
		case GSFMT_A4R4G4B4:
			{
				GS_INIT_444TABLE();

				for( h = 0; h < lpNewImgInfo->nHeight; h++ )
				{
					WORD* pSrcBits = (WORD*)ppScanLine[h];
					int d = 0;

					for( w = 0; w < lpNewImgInfo->nWidth; w++ )
					{
						pBits[d+0] = GS_A4R4G4B4ToB8(pSrcBits[w]);
						pBits[d+1] = GS_A4R4G4B4ToG8(pSrcBits[w]);
						pBits[d+2] = GS_A4R4G4B4ToR8(pSrcBits[w]);
						d+=3;
					}

					// 4oCgE̎coCg0Ŗ߂
					::memset( &pBits[d], 0, lpNewImgInfo->dwRowBytes-d );

					pBits += lpNewImgInfo->dwRowBytes;
				}
			}
			break;
		case GSFMT_R3G3B2:		// 8rbg 332
			{
				GS_INIT_332TABLE();

				for( h = 0; h < lpNewImgInfo->nHeight; h++ )
				{
					int d = 0;

					for( w = 0; w < lpNewImgInfo->nWidth; w++ )
					{
						pBits[d+0] = GS_R3G3B2ToB8(ppScanLine[h][w]);
						pBits[d+1] = GS_R3G3B2ToG8(ppScanLine[h][w]);
						pBits[d+2] = GS_R3G3B2ToR8(ppScanLine[h][w]);
						d+=3;
					}

					// 4oCgE̎coCg0Ŗ߂
					::memset( &pBits[d], 0, lpNewImgInfo->dwRowBytes-d );

					pBits += lpNewImgInfo->dwRowBytes;
				}
			}
			break;
		case GSFMT_A8R3G3B2:	// 16rbg 332
			{
				GS_INIT_332TABLE();

				for( h = 0; h < lpNewImgInfo->nHeight; h++ )
				{
					WORD* pSrcBits = (WORD*)ppScanLine[h];
					int d = 0;

					for( w = 0; w < lpNewImgInfo->nWidth; w++ )
					{
						pBits[d+0] = GS_A8R3G3B2ToB8(pSrcBits[w]);
						pBits[d+1] = GS_A8R3G3B2ToG8(pSrcBits[w]);
						pBits[d+2] = GS_A8R3G3B2ToR8(pSrcBits[w]);
						d+=3;
					}

					// 4oCgE̎coCg0Ŗ߂
					::memset( &pBits[d], 0, lpNewImgInfo->dwRowBytes-d );

					pBits += lpNewImgInfo->dwRowBytes;
				}
			}
			break;
		case GSFMT_P8:			// 8rbgpbg

			if( !lpImgInfo->lpPalette )
			{
				ret = false;
				break;
			}

			for( h = 0; h < lpNewImgInfo->nHeight; h++ )
			{
				int d = 0;

				for( w = 0; w < lpNewImgInfo->nWidth; w++ )
				{
					pBits[d+0] = lpImgInfo->lpPalette[ppScanLine[h][w]].rgbBlue;
					pBits[d+1] = lpImgInfo->lpPalette[ppScanLine[h][w]].rgbGreen;
					pBits[d+2] = lpImgInfo->lpPalette[ppScanLine[h][w]].rgbRed;
					d+=3;
				}

				// 4oCgE̎coCg0Ŗ߂
				::memset( &pBits[d], 0, lpNewImgInfo->dwRowBytes-d );

				pBits += lpNewImgInfo->dwRowBytes;
			} 
			break;
		default:
			ret = false;
			SAFE_DELETE_ARRAY( lpNewImgInfo->lpBits );
		}
		break;
	case GSPICBPP_32:	// 32rbgtsN`(BMP,PNG,TGA)

		lpNewImgInfo->dwRowBytes = GS_GETBMPROWBYTES( lpNewImgInfo->nWidth, 4 );
		lpNewImgInfo->dwSize	 = lpNewImgInfo->dwRowBytes*lpNewImgInfo->nHeight;
		lpNewImgInfo->Format     = GSFMT_A8R8G8B8;
		lpNewImgInfo->lpBits     = new BYTE[ lpNewImgInfo->dwSize ];
		pBits = (LPBYTE)lpNewImgInfo->lpBits;

		switch( lpImgInfo->Format )
		{
		case GSFMT_R8G8B8:		// 24rbg

			for( h = 0; h < lpNewImgInfo->nHeight; h++ )
			{
				int d = 0;
				int s = 0;

				for( w = 0; w < lpNewImgInfo->nWidth; w++ )
				{
					::memmove( &pBits[d], &ppScanLine[h][s], 3 );
					pBits[d+3] = 0xFF;					// A
					d+=4;
					s+=3;
				}

				pBits += lpNewImgInfo->dwRowBytes;
			}
			break;
		case GSFMT_X8R8G8B8:	// 32rbg
		case GSFMT_A8R8G8B8:

			for( h = 0; h < lpNewImgInfo->nHeight; h++ )
			{
				int d = 0;

				for( w = 0; w < lpNewImgInfo->nWidth; w++ )
				{
					::memmove( &pBits[d], &ppScanLine[h][d], 4 );
					d+=4;
				}

				pBits += lpNewImgInfo->dwRowBytes;
			}
			break;
		case GSFMT_R5G6B5:		// 16rbg 565
			{
				GS_INIT_565TABLE();

				for( h = 0; h < lpNewImgInfo->nHeight; h++ )
				{
					WORD* pSrcBits = (WORD*)ppScanLine[h];
					int d = 0;

					for( w = 0; w < lpNewImgInfo->nWidth; w++ )
					{
						pBits[d+0] = GS_R5G6B5ToB8(pSrcBits[w]);
						pBits[d+1] = GS_R5G6B5ToG8(pSrcBits[w]);
						pBits[d+2] = GS_R5G6B5ToR8(pSrcBits[w]);
						pBits[d+3] = 0xFF;								// A
						d+=4;
					}

					pBits += lpNewImgInfo->dwRowBytes;
				}
			}
			break;
		case GSFMT_X1R5G5B5:	// 16rbg 555
		case GSFMT_A1R5G5B5:
			{
				GS_INIT_555TABLE();

				for( h = 0; h < lpNewImgInfo->nHeight; h++ )
				{
					WORD* pSrcBits = (WORD*)ppScanLine[h];
					int d = 0;

					for( w = 0; w < lpNewImgInfo->nWidth; w++ )
					{
						pBits[d+0] = GS_A1R5G5B5ToB8(pSrcBits[w]);
						pBits[d+1] = GS_A1R5G5B5ToG8(pSrcBits[w]);
						pBits[d+2] = GS_A1R5G5B5ToR8(pSrcBits[w]);
						pBits[d+3] = GS_A1R5G5B5ToA8(pSrcBits[w]);
						d+=4;
					}

					pBits += lpNewImgInfo->dwRowBytes;
				}
			}
			break;
		case GSFMT_X4R4G4B4:	// 16rbg 444
		case GSFMT_A4R4G4B4:
			{
				GS_INIT_444TABLE();

				for( h = 0; h < lpNewImgInfo->nHeight; h++ )
				{
					WORD* pSrcBits = (WORD*)ppScanLine[h];
					int d = 0;

					for( w = 0; w < lpNewImgInfo->nWidth; w++ )
					{
						pBits[d+0] = GS_A4R4G4B4ToB8(pSrcBits[w]);
						pBits[d+1] = GS_A4R4G4B4ToG8(pSrcBits[w]);
						pBits[d+2] = GS_A4R4G4B4ToR8(pSrcBits[w]);
						pBits[d+3] = GS_A4R4G4B4ToA8(pSrcBits[w]);
						d+=4;
					}

					pBits += lpNewImgInfo->dwRowBytes;
				}
			}
			break;
		case GSFMT_R3G3B2:		// 8rbg 332
			{
				GS_INIT_332TABLE();

				for( h = 0; h < lpNewImgInfo->nHeight; h++ )
				{
					int d = 0;

					for( w = 0; w < lpNewImgInfo->nWidth; w++ )
					{
						pBits[d+0] = GS_R3G3B2ToB8(ppScanLine[h][w]);
						pBits[d+1] = GS_R3G3B2ToG8(ppScanLine[h][w]);
						pBits[d+2] = GS_R3G3B2ToR8(ppScanLine[h][w]);
						pBits[d+3] = 0xFF;
						d+=4;
					}

					pBits += lpNewImgInfo->dwRowBytes;
				}
			}
			break;
		case GSFMT_A8R3G3B2:	// 16rbg 332
			{
				GS_INIT_332TABLE();

				for( h = 0; h < lpNewImgInfo->nHeight; h++ )
				{
					WORD* pSrcBits = (WORD*)ppScanLine[h];
					int d = 0;

					for( w = 0; w < lpNewImgInfo->nWidth; w++ )
					{
						pBits[d+0] = GS_A8R3G3B2ToB8(pSrcBits[w]);
						pBits[d+1] = GS_A8R3G3B2ToG8(pSrcBits[w]);
						pBits[d+2] = GS_A8R3G3B2ToR8(pSrcBits[w]);
						pBits[d+3] = GS_A8R3G3B2ToA8(pSrcBits[w]);
						d+=4;
					}

					pBits += lpNewImgInfo->dwRowBytes;
				}
			}
			break;
		case GSFMT_P8:			// 8rbgpbg

			if( !lpImgInfo->lpPalette )
			{
				ret = false;
				break;
			}

			for( h = 0; h < lpNewImgInfo->nHeight; h++ )
			{
				int d = 0;

				for( w = 0; w < lpNewImgInfo->nWidth; w++ )
				{
					pBits[d+0] = lpImgInfo->lpPalette[ppScanLine[h][w]].rgbBlue;
					pBits[d+1] = lpImgInfo->lpPalette[ppScanLine[h][w]].rgbGreen;
					pBits[d+2] = lpImgInfo->lpPalette[ppScanLine[h][w]].rgbRed;
					pBits[d+3] = 0xFF;
					d+=4;
				}

				pBits += lpNewImgInfo->dwRowBytes;
			}
			break;
		default:
			ret = false;
			SAFE_DELETE_ARRAY( lpNewImgInfo->lpBits );
		}
		break;
	default:
		ret = false;
	}

	return ret;
}


/*----------------------------------------------------------------------------*
|	BITMAPۑ
*----------------------------------------------------------------------------*/
void CGraphicSaver::SaveBitmap( CFile& fout, const LPGSIMAGEINFO lpImgInfo )
{

	BITMAPFILEHEADER bf = { 0 };
	BITMAPINFOHEADER bi = { 0 };

	// rbg}bvt@C\̐ݒ
	bf.bfType    = 0x4D42;
	bf.bfOffBits = sizeof( BITMAPFILEHEADER )+sizeof( BITMAPINFOHEADER )+sizeof(RGBQUAD)*(lpImgInfo->lpPalette?256:0);
	bf.bfSize    = lpImgInfo->dwSize+bf.bfOffBits;

	// rbg}bvCtH\̐ݒ
	bi.biSize        = sizeof( BITMAPINFOHEADER );
	bi.biWidth       = lpImgInfo->nWidth;
	bi.biHeight      = lpImgInfo->nHeight;
	bi.biPlanes      = 1;
	bi.biCompression = BI_RGB;
	bi.biSizeImage   = lpImgInfo->dwSize;

	// rbgJEgݒ
	switch( lpImgInfo->Format )
	{
	case GSFMT_P8:

		bi.biBitCount = 8;
		break;
	case GSFMT_R8G8B8:

		bi.biBitCount = 24;
		break;
	case GSFMT_A8R8G8B8:

		bi.biBitCount = 32;
		break;
	}

	// wb_[
	fout.Write( &bf, sizeof( BITMAPFILEHEADER ), 1 );
	fout.Write( &bi, sizeof(BITMAPINFOHEADER), 1 );
	
	if( lpImgInfo->lpPalette )
	{
		// pbg
		fout.Write( lpImgInfo->lpPalette, sizeof(RGBQUAD), 256 );
	}
	
	// sNZ
	fout.Write( lpImgInfo->lpBits, sizeof(BYTE), lpImgInfo->dwSize );

}


/*----------------------------------------------------------------------------*
|	JPEGۑ
*----------------------------------------------------------------------------*/
void CGraphicSaver::SaveJpeg( CFile& fout, const LPGSIMAGEINFO lpImgInfo, BOOL bProgression, DWORD dwQuality )
{

	jpeg_compress_struct cinfo;
    jpeg_error_mgr jerr;

	// G[̃nhO
	cinfo.err = ::jpeg_std_error( &jerr );

	// \̂̏ݒ
    ::jpeg_create_compress( &cinfo );

	// t@C̓nh̐ݒ
	::jpeg_stdio_dest( &cinfo, fout );

	// p[^ݒ
	cinfo.image_width  = lpImgInfo->nWidth;
    cinfo.image_height = lpImgInfo->nHeight;
    cinfo.input_components = 3;			// sNZ̐F
    cinfo.in_color_space = JCS_RGB;		// J[Xy[X

	// ftHgkp[^
	::jpeg_set_defaults( &cinfo );

	// i̐ݒ
	::jpeg_set_quality( &cinfo, dwQuality, TRUE );

	// vObVuGR[fBO
	if( bProgression )  ::jpeg_simple_progression( &cinfo );

	// kJn
	::jpeg_start_compress( &cinfo, TRUE );

	JSAMPROW buffer[1];
	BYTE temp;

	LPBYTE pBits = (LPBYTE)lpImgInfo->lpBits+lpImgInfo->dwRowBytes*(lpImgInfo->nHeight-1);
	int row_stride = lpImgInfo->nWidth*3;

	while( cinfo.next_scanline < cinfo.image_height )
	{
		// bufferBGRȂ̂RGBɕϊ
		for( int i = 0; i < row_stride; i+=3 )
		{
			temp = pBits[i+0];
			pBits[i+0] = pBits[i+2];
			pBits[i+2] = temp;

		}

		// 1s
		buffer[0] = pBits;
		::jpeg_write_scanlines(&cinfo, buffer, 1);

		// ̃C
		pBits -= lpImgInfo->dwRowBytes;
	}

	// I
	::jpeg_finish_compress( &cinfo );
	::jpeg_destroy_compress( &cinfo );

}

/*----------------------------------------------------------------------------*
|	PNGۑ
*----------------------------------------------------------------------------*/
void CGraphicSaver::SavePng( CFile& fout, const LPGSIMAGEINFO lpImgInfo )
{

	png_structp png_ptr  = NULL;
    png_infop   info_ptr = NULL;

	// PNG \̂̎擾
	png_ptr = ::png_create_write_struct( PNG_LIBPNG_VER_STRING, NULL, NULL, NULL );

	if( !png_ptr ) return;

	// PNG \̂̎擾
	info_ptr = ::png_create_info_struct( png_ptr );

	if( !info_ptr ) return;

	// t@Cnhݒ
	::png_init_io( png_ptr, fout );

	int nColorType;

	switch( lpImgInfo->Format )
	{
	case GSFMT_P8:
		{
			// 8rbg
			nColorType = PNG_COLOR_TYPE_PALETTE;

			png_color Palette[ 256 ];

			for( int n = 0; n < 256; n++ )
			{
				Palette[ n ].red   = lpImgInfo->lpPalette[ n ].rgbRed;
				Palette[ n ].green = lpImgInfo->lpPalette[ n ].rgbGreen;
				Palette[ n ].blue  = lpImgInfo->lpPalette[ n ].rgbBlue;
			}

			// pbgݒ
			::png_set_PLTE( png_ptr, info_ptr, Palette, 256 );
		}
		break;
	case GSFMT_R8G8B8:

		// 24rbg
		nColorType = PNG_COLOR_TYPE_RGB;

		// RGBBGRɕϊ
		::png_set_bgr( png_ptr );
		break;
	case GSFMT_A8R8G8B8:

		// 32rbg
		nColorType = PNG_COLOR_TYPE_RGB_ALPHA;

		// RGBBGRɕϊ
		::png_set_bgr( png_ptr );
		break;
	}

	// ̐ݒ
	::png_set_IHDR( png_ptr, info_ptr, lpImgInfo->nWidth, lpImgInfo->nHeight, 8,
              nColorType, NULL, NULL, NULL );

	// XLCobt@m
	auto_array<png_bytep> ppScanLine( new png_bytep[ lpImgInfo->nHeight ] );
	png_bytep lpBits = (png_bytep)lpImgInfo->lpBits;

	// XLCݒ
	for( int i = lpImgInfo->nHeight-1; i >= 0 ; i-- )
	{
		ppScanLine[i] = lpBits;
		lpBits += lpImgInfo->dwRowBytes;
	}

	// t@Cɏ
	::png_write_info( png_ptr, info_ptr );
    ::png_write_image( png_ptr, ppScanLine );
    ::png_write_end( png_ptr, info_ptr );

	// I
    ::png_destroy_write_struct( &png_ptr, &info_ptr );

}


/*----------------------------------------------------------------------------*
|	TARGAۑ
*----------------------------------------------------------------------------*/
void CGraphicSaver::SaveTarga( CFile& fout, const LPGSIMAGEINFO lpImgInfo )
{
	TARGAHEADER th = { 0 };
	TARGAFOOTER tf = { 0 };
	TARGAEXTFOOTER tef = { 0 };

	th.Width  = lpImgInfo->nWidth;
	th.Height = lpImgInfo->nHeight;

	// erbgɂƂÂp[^ݒ
	switch( lpImgInfo->Format )
	{
	case GSFMT_P8:
		
		th.Pixel	      = 8;
		th.CMap_Type      = 1;
		th.Image_Type	  = 1;
		th.CMap_Length	  = 256;
		th.CMap_EntrySize = 24;
		break;
	case GSFMT_R8G8B8:

		th.Pixel	  = 24;
		th.Image_Type = 2;
		th.IDesc_Type = 8;
		break;
	case GSFMT_A8R8G8B8:

		th.Pixel	  = 32;
		th.Image_Type = 2;
		th.IDesc_Type = 8;
		break;
	}

	// GNXeVtb^[̃p[^ݒ
	tef.len = sizeof(TARGAEXTFOOTER);

	::strcpy( tef.author, "" );
	::strcpy( tef.comment, "http://selna.hp.infoseek.co.jp/" );
	::strcpy( tef.job, "" );
	::strcpy( tef.soft, "" );
	::memset( &tef.author[strlen(tef.author)], ' ', 40-strlen(tef.author) );
	::memset( &tef.comment[strlen(tef.comment)], ' ', 323-strlen(tef.comment) );
	::memset( &tef.job[strlen(tef.job)], ' ', 40-strlen(tef.job) );
	::memset( &tef.soft[strlen(tef.soft)], ' ', 40-strlen(tef.soft) );
	tef.author[40]   = '\0';	
	tef.comment[323] = '\0';	
	tef.job[40]		 = '\0';	
	tef.soft[40]	 = '\0';

	SYSTEMTIME st;
	::GetLocalTime( &st );

	tef.date.year	= st.wYear;
	tef.date.month  = st.wMonth;
	tef.date.day	= st.wDay;
	tef.date.hour	= st.wHour;
	tef.date.minute = st.wMinute;
	tef.date.second = st.wMinute;
	tef.time.hours	= st.wHour;
	tef.time.minute = st.wMinute;
	tef.time.second = st.wSecond;

	tef.att_type	= th.Pixel==32?3:0;
	tef.verNunber	= 1280;

	// tb^[p[^̐ݒ
	tf.Ext_Ofs = sizeof(TARGAHEADER)+3*(lpImgInfo->lpPalette?256:0)+th.Width*th.Height*(th.Pixel>>3);
	::strcpy( tf.Sign, "TRUEVISION-XFILE." );

	// wb_[
	fout.Write( &th, sizeof(TARGAHEADER), 1 );

	// pbg
	if( lpImgInfo->lpPalette )
	{
		for( int n = 0; n < 256; n++ )
		{
			fout.Write( &lpImgInfo->lpPalette[n], sizeof(BYTE), 3 );
		}
	}

	// sNZ
	LPBYTE pBits = (LPBYTE)lpImgInfo->lpBits;

	for( int h = 0; h < th.Height; h++ )
	{
		fout.Write( pBits, th.Pixel>>3, lpImgInfo->nWidth );
		pBits += lpImgInfo->dwRowBytes;
	}

	// tb^[
	fout.Write( &tef, sizeof(TARGAEXTFOOTER), 1 );
	fout.Write( &tf, sizeof(TARGAFOOTER), 1 );
}


#endif /* SLIB_USE_GRAPHICSAVER */