#ifndef _INC_FACTORY
#define _INC_FACTORY


/*----------------------------------------------------------------------------*
|	Factory Base Class (Factory Method Pattern)
*----------------------------------------------------------------------------*/
class CFactoryBase
{
public:
	virtual void* CreateInstance( void ) = 0;
};


/*----------------------------------------------------------------------------*
|	Factory Template Class
*----------------------------------------------------------------------------*/
template <class T>
class CFactory : public CFactoryBase
{
public:
	virtual void* CreateInstance( void ) {
		return new(nothrow) T;
		/*
		try {
			return new T;
		} catch( bad_alloc ) {
			return NULL;
		}
		*/
	}
};


#endif /* _INC_FACTORY */