#ifndef _INC_SLIB_CGRAPHICLOADER
#define _INC_SLIB_CGRAPHICLOADER
#ifdef SLIB_USE_GRAPHICLOADER


// sNZtH[}bg
typedef enum
{
    GLFMT_R8G8B8	= 20,	// 24 rbg RGB sNZ tH[}bg
    GLFMT_A8R8G8B8	= 21,	// At@t 32 rbg ARGB sNZ tH[}bgB
    GLFMT_X8R8G8B8	= 22,	// 32 rbg RGB sNZ tH[}bgŁÂ 8 rbg͊eF̂߂ɊmۂĂB
    GLFMT_R5G6B5	= 23,	// 16 rbg RGB sNZ tH[}bgB
    GLFMT_X1R5G5B5	= 24,	// 16 rbg̃sNZ tH[}bgŁÂ 5 rbg͊eF̂߂ɊmۂĂB
    GLFMT_A1R5G5B5	= 25,	// 16 rbg̃sNZ tH[}bgŁAeF 5 rbgAAt@ (ߌ^eNZ)  1 rbgAꂼmۂĂB 
    GLFMT_A4R4G4B4	= 26,	// 16 rbg ARGB sNZ tH[}bgB
    GLFMT_R3G3B2	= 27,	// 8 rbg RGB eNX` tH[}bgB
    GLFMT_A8R3G3B2	= 29,	// 16 rbg ARGB eNX` tH[}bgB
    GLFMT_X4R4G4B4	= 30,	// 16 rbg RGB sNZ tH[}bgŁÂ 4 rbg͊eF̂߂ɊmۂĂB
	GLFMT_P8		= 41,	// 8 rbg̃J[ CfbNXtH[}bgB

}GLFORMAT;

// BITMAP̉̃oCg𓾂(4oCgEɏC)
#define GL_GETBMPROWBYTES( w, b ) ((((w)*(b))+3)&~3)

// 24rbgRGBtH[}bg̕ϊ}N
#define GL_R8G8B8ToA1R5G5B5( a, r, g, b ) (WORD)((a>>7)<<15|(r>>3)<<10|(g>>3)<<5|(b>>3))
#define GL_R8G8B8ToR5G6B5( r, g, b ) (WORD)((r>>3)<<11|(g>>2)<<5|(b>>3))
#define GL_R8G8B8ToA4R4G4B4( a, r, g, b ) (WORD)((a>>4)<<12|(r>>4)<<8|(g>>4)<<4|(b>>4))
#define GL_R8G8B8ToR3G3B2( r, g, b ) (BYTE)((r>>5)<<5|(g>>5)<<2|(b>>6))
#define GL_R8G8B8ToA8R3G3B2( a, r, g, b ) (WORD)((a)<<8|(r>>5)<<5|(g>>5)<<2|(b>>6))


/*----------------------------------------------------------------------------*
|	OtBbNǂݍ݃NX (OtBbNDIBϊ)
*----------------------------------------------------------------------------*/
typedef class CGraphicLoader
{
protected:

	HLOCAL	m_hBmpInfo;
	HLOCAL	m_hBmpBits;

	// SPI֐
	typedef int (CALLBACK *SPI_PROGRESS)(int, int, long);
	typedef int (WINAPI *SpiIsSupported)(LPSTR filename, DWORD dw);
	typedef int (WINAPI *SpiGetPicture)(LPSTR buf, long len, unsigned int flag, HANDLE *pHBInfo, HANDLE *pHBm, SPI_PROGRESS lpPrgressCallback, long lData);

	// JPEGŎgpG[\̂g
	typedef struct : public jpeg_error_mgr {
		jmp_buf setjmp_buffer;
	}gl_jpeg_error_mgr, FAR* gl_jpeg_error_ptr;

protected:

	// C[Wǂݍ݊֐
	bool LoadBitmap( LPVOID lpVoid, LONG nLen, BOOL bMem );
	bool LoadTarga( LPVOID lpVoid, LONG nLen, BOOL bMem );
	bool LoadJpeg( LPVOID lpVoid, LONG nLen, BOOL bMem );
	bool LoadPng( LPVOID lpVoid, LONG nLen, BOOL bMem );
	bool LoadBySPI( LPVOID lpVoid, LONG nLen, BOOL bMem, const char* lpszSpiDir );
	
	// JPEG̃G[֐
	static void JpegErrorExit( j_common_ptr cinfo ) {
		::longjmp( ((gl_jpeg_error_ptr)cinfo->err)->setjmp_buffer, true );
	}

	// PNG̃[[h֐
	static void PngMemRead( png_structp png_ptr, png_bytep pngbuf_ptr, png_size_t size )
	{
		LPBYTE* ppBuf =(LPBYTE*)::png_get_io_ptr( png_ptr );
		::memmove( pngbuf_ptr, *ppBuf, size );
		*ppBuf += size;
	}
	
public:

	CGraphicLoader();
	virtual ~CGraphicLoader();

	virtual void Release( void );
	BOOL GetSize( SIZE* pSize );
	BOOL GetBitmapInfo( BITMAPINFO* pBmi );
	BOOL GetPalette( LPPALETTEENTRY pPal );
	BOOL GetPalette( LPRGBQUAD pPal );
	HLOCAL GetHBmpInfo( void ) { return m_hBmpInfo; }
	HLOCAL GetHBmpBits( void ) { return m_hBmpBits; }

	void LoadPicture( LPCVOID lpBuf, long nLen=0, BOOL bMem=FALSE, const char* lpszSpiDir=NULL );

	BOOL Render( LPVOID lpBuf, DWORD dwDstRowBytes, GLFORMAT ConvFormat );
	BOOL Render( HDC hdc );

}CGRAPHICLOADER, FAR* LPCGRAPHICLOADER;


#endif /* SLIB_USE_GRAPHICLOADER */
#endif /* _INC_SLIB_CGRAPHICLOADER */