#ifndef _INC_SLIB_auto_ptrEx
#define _INC_SLIB_auto_ptrEx

#ifndef _TRACE
#define _TRACE
#endif

namespace selna
{

/*----------------------------------------------------------------------------*
|	auto_ptrEx STL auto_ptr̉ǔ ev[gNX
*----------------------------------------------------------------------------*/
template <class T> class auto_ptrEx
{
protected:

	bool	_Owns;		// |C^̏L
	T*		_Ptr;		// |C^

	typedef auto_ptrEx<T> this_type;

public:

	// RXgN^ (|C^0łȂL)
	explicit auto_ptrEx( T* _P = 0 ) : _Owns(_P != 0), _Ptr(_P) { if(_Ptr) _TRACE("new auto_ptrEx::auto_ptrEx _Ptr=%#08x this=%#08x\n",_Ptr,this); }

	// Rs[RXgN^ (|C^ړLn)
	auto_ptrEx( const auto_ptrEx<T>& _rhs ) : _Owns(_rhs._Owns), _Ptr(_rhs.release()) { if(_Ptr) _TRACE("copy auto_ptrEx::auto_ptrEx _Ptr=%#08x this=%#08x\n",_Ptr,this); }

	// fXgN^ (L鎞|C^폜)
	~auto_ptrEx() { if( _Owns ){ delete _Ptr; _TRACE("delete auto_ptrEx::~auto_ptrEx _Ptr=%#08x this=%#08x\n",_Ptr,this);} }

	// Rs[ 
	// (|C^ꍇŏL鎞n
	// |C^ႤꍇA|C^͍폜ꏊLn
	// ̌Eӑ̐|C^Rs[)
	auto_ptrEx<T>& operator=( const auto_ptrEx<T>& _rhs ) {
		if( this != &_rhs ) {
			if( _Ptr != _rhs._Ptr ) {
				if( _Owns ){ delete _Ptr; _TRACE("delete auto_ptrEx::operator= _Ptr=%#08x this=%#08x\n",_Ptr,this); }
				_Owns = _rhs._Owns;
			}else if( _rhs._Owns ) {
				_Owns = true;
			}
			_Ptr = _rhs.release();
			if(_Ptr) _TRACE("copy auto_ptrEx::operator= _Ptr=%#08x this=%#08x\n",_Ptr,this);
		}
		return *this;
	}

	// |C^̒l擾
	T& operator*() const { return *_Ptr; }

	// |C^̃oփANZX
	T* operator->() const {	return _Ptr; }

	// |C^擾
	T* get( void ) const { return _Ptr;	}

	// L̉
	T* release( void ) const {
		const_cast<this_type*>(this)->_Owns = false;
		return _Ptr;
	}

	// STL auto_ptrƂ܂œňȉIWi (boostQl)

	// |C^_PŃZbg (_P0łȂꍇL)
	void reset( T* _P = 0 ) {
		// XR[v甲ƃfXgN^N
		// (LĂꍇ|C^͍폜)
		this_type(_P).swap(*this);
		// *this = this_type(_P); ɓ
	}

	// Xbv (l)
	void swap( auto_ptrEx<T>& b ) {
		T*		tmpPtr  = b._Ptr;
		bool	tmpOwns = b._Owns;
		b._Ptr  = _Ptr;
		b._Owns = _Owns;
		_Ptr  = tmpPtr;
		_Owns = tmpOwns;
	}

	// |C^擾 (T*ŃLXg)
	operator T*() const { return _Ptr; }

};

};

#endif /* _INC_SLIB_auto_ptrEx */