#ifndef _INC_SLIB_shared_array
#define _INC_SLIB_shared_array

#ifndef _TRACE
#define _TRACE
#endif

namespace selna
{

/*----------------------------------------------------------------------------*
|	shared_ptr L|C^z ev[gNX
*----------------------------------------------------------------------------*/
template <class T> class shared_array
{
protected:

	unsigned long*	_Ref;		// t@XJE^
	T*				_Ptr;		// |C^

	typedef shared_array<T> this_type;

public:

	// RXgN^ (t@XJE^)
	explicit shared_array( T* _P = 0 ) : _Ref(new unsigned long(1)), _Ptr(_P) { if(_Ptr) _TRACE("new [] shared_array::shared_array _Ptr=%#08x this=%#08x\n",_Ptr,this); }

	// Rs[RXgN^ (̂܂܃Rs[)
	shared_array( const shared_array<T>& _rhs ) : _Ref(_rhs._Ref), _Ptr(_rhs._Ptr) { (*_rhs._Ref)++; if(_Ptr) _TRACE("copy shared_array::shared_array _Ptr=%#08x this=%#08x\n",_Ptr,this); }

	// fXgN^ (QƃJE^fNgQƐ悪Ȃꍇ|C^폜)
	~shared_array() {
		(*_Ref)--;
		if( *_Ref == 0 ) {
			_TRACE("delete [] shared_array::~shared_array _Ptr=%#08x this=%#08x\n",_Ptr,this);
			delete _Ref;
			delete [] _Ptr;
		}
	}

	// Rs[
	// (QƃJE^fNgQƐ悪Ȃꍇ|C^폜A
	// Eӑ̎QƃJE^CNg
	// ̌Eӑ̃X}[g|C^Rs[)
	shared_array<T>& operator=( const shared_array<T>& _rhs ) {
		if( this != &_rhs ) {
			if( _Ptr != _rhs._Ptr ) {
				(*_Ref)--;
				if( *_Ref == 0 ) {
					_TRACE("delete [] shared_array::operator= _Ptr=%#08x this=%#08x\n",_Ptr,this);
					delete _Ref;
					delete [] _Ptr;
				}
				(*_rhs._Ref)++;
				_Ref = _rhs._Ref;
				_Ptr = _rhs._Ptr;
				if(_Ptr) _TRACE("copy shared_array::operator= _Ptr=%#08x this=%#08x\n",_Ptr,this);
			}
		}
		return *this;
	}

	// |C^̒l擾
	T& operator[]( int i ) const { return _Ptr[i]; }

	// |C^擾
	T* get( int i = 0 ) const { return &_Ptr[i]; }

	// |C^_PŃZbg
	void reset( T* _P = 0 ) {
		// XR[v甲ƃfXgN^N
		this_type(_P).swap(*this);
		// *this = this_type(_P); ɓ
	}

	// Xbv (l)
	void swap( shared_array<T>& b ) {
		T*				tmpPtr = b._Ptr;
		unsigned long*	tmpRef = b._Ref;
		b._Ptr = _Ptr;
		b._Ref = _Ref;
		_Ptr = tmpPtr;
		_Ref = tmpRef;
	}

	// |C^擾 (T*ŃLXg)
	operator T*() const { return _Ptr; }

};

};

#endif /* _INC_SLIB_shared_array */